! **************************************************************** 
!                                                                  
! Generated by KPP - symbolic chemistry Kinetics PreProcessor      
!     KPP is developed at CGRER labs University of Iowa by         
!     Valeriu Damian & Adrian Sandu                                
!                                                                  
! File                 : mecca_module.f90                          
! Time                 : Sun Jan 23 15:29:02 2005                  
! Working directory    : /home/sander/messy/mecca-acp/mecca        
! Equation file        : mecca.k                                   
! Output root filename : mecca                                     
!                                                                  
! **************************************************************** 


MODULE messy_mecca_kpp_g_mem

IMPLICIT NONE

SAVE

! dp - definition of double precision                              
      INTEGER, PARAMETER :: dp = SELECTED_REAL_KIND(12,307)

! NSPEC - The number of species involved                           
      INTEGER, PARAMETER :: NSPEC = 208 
! NVAR - The number of Variable species                            
      INTEGER, PARAMETER :: NVAR = 203 
! NVARACT - The number of Active species                           
      INTEGER, PARAMETER :: NVARACT = 199 
! NRAD - The number of Radical species                             
      INTEGER, PARAMETER :: NRAD = 1 
! NFIX - The number of Fixed species                               
      INTEGER, PARAMETER :: NFIX = 5 
! NREACT - The number of reactions                                 
      INTEGER, PARAMETER :: NREACT = 659 
! NVARST - Starting of variables in conc. vect.                    
      INTEGER, PARAMETER :: NVARST = 0 
! NRADST - Starting of radicals in conc. vect.                     
      INTEGER, PARAMETER :: NRADST = 203 
! NFIXST - Starting of fixed in conc. vect.                        
      INTEGER, PARAMETER :: NFIXST = 203 
! NONZERO_V - Number of nonzero variable elements                  
      INTEGER, PARAMETER :: NONZERO_V = 2012 
! LU_NONZERO_V - Number of nonzero variable LU elements            
      INTEGER, PARAMETER :: LU_NONZERO_V = 4678 
! NONZERO_R - Number of nonzero radical elements                   
      INTEGER, PARAMETER :: NONZERO_R = 0 
! CNVAR - (NVAR+1) The number of elements in compressed row format 
      INTEGER, PARAMETER :: CNVAR = NVAR + 1 
! CNRAD - (NRAD+1) The number of elements in compressed row format 
      INTEGER, PARAMETER :: CNRAD = NRAD + 1 
! NLOOKAT - number of species to look at                           
      INTEGER, PARAMETER :: NLOOKAT = 0 
! NMONITOR - number of species to monitor                          
      INTEGER, PARAMETER :: NMONITOR = 0 
! NMASS - number of atoms to check mass balance                    
      INTEGER, PARAMETER :: NMASS = 0 
! NX - X grid dimension                                            
      INTEGER, PARAMETER :: NX = 0 
! NY - Y grid dimension                                            
      INTEGER, PARAMETER :: NY = 0 
! NZ - Z grid dimension                                            
      INTEGER, PARAMETER :: NZ = 0 
! MAX_XYZ - maximum grid dimension                                 
      INTEGER, PARAMETER :: MAX_XYZ = 0 
! NS - number of species to transport                              
      INTEGER, PARAMETER :: NS = 0 
! PI - Value of pi                                                 
      REAL(dp), PARAMETER :: PI = 3.14159265358979 

! Declaration for global variables                                 


! C_DEFAULT - Default concentration for all species                
      REAL(dp), DIMENSION(NSPEC) :: C_DEFAULT
! C - Concentration for all species                                
      REAL(dp), DIMENSION(NSPEC) :: C
! VAR - Concentration of variable species (global)                 
      REAL(dp), DIMENSION(NVAR) :: VAR
! RAD - Concentration of radicals (global)                         
      REAL(dp), DIMENSION(NRAD) :: RAD
! FIX - Concentration of fix species (global)                      
      REAL(dp), DIMENSION(NFIX) :: FIX
! F - Concentration of fix species (global)                        
      REAL(dp), DIMENSION(NFIX) :: F
      EQUIVALENCE( C(1+NVARST),VAR(1) )
      EQUIVALENCE( C(1+NRADST),RAD(1) )
      EQUIVALENCE( C(1+NFIXST),FIX(1) )
      EQUIVALENCE( C(1+NFIXST),F(1) )
! RCONST - Rate constants                                          
      REAL(dp), DIMENSION(NREACT) :: RCONST
! TIME - current integration time                                  
      REAL(dp) :: TIME
! SUN - light intensity                                            
      REAL(dp) :: SUN
! RTOLS - (scalar) relative tolerance                              
      REAL(dp) :: RTOLS
! TSTART - integration start time                                  
      REAL(dp) :: TSTART
! TEND - integration end time                                      
      REAL(dp) :: TEND
! DT - integration step                                            
      REAL(dp) :: DT
! ATOL - Absolute tolerance                                        
      REAL(dp), DIMENSION(NSPEC) :: ATOL
! RTOL - Relative tolerance                                        
      REAL(dp), DIMENSION(NSPEC) :: RTOL
! STEPMIN - minimum allowed intergation step                       
      REAL(dp) :: STEPMIN
! STEPMAX - maximum allowed integration step                       
      REAL(dp) :: STEPMAX
! CFACTOR - Conversion factor                                      
      REAL(dp) :: CFACTOR = 10900000000.000000      
! LOOKAT - indexes of species to look at                           
      INTEGER, DIMENSION(1) :: LOOKAT      
! SLOOKAT - names of species to look at                            
      CHARACTER*12, DIMENSION(1) :: SLOOKAT      
! MONITOR - indexes of species to monitor                          
      INTEGER, DIMENSION(1) :: MONITOR      
! SMONITOR - names of species to monitor                           
      CHARACTER*12, DIMENSION(1) :: SMONITOR      
! TRANS - indexes of species to transport                          
      INTEGER, DIMENSION(NS+1) :: TRANS
! STRANS - names of species to transport                           
      CHARACTER*12, DIMENSION(NS+1) :: STRANS
! SMASS - names of atoms for mass balance                          
      CHARACTER*12, DIMENSION(1) :: SMASS      

! Indexes declaration for variable species                         

      INTEGER, PARAMETER :: I_CH3I = 1 
      INTEGER, PARAMETER :: I_CH2I2 = 2 
      INTEGER, PARAMETER :: I_CH2ClI = 3 
      INTEGER, PARAMETER :: I_IO3m_as = 4 
      INTEGER, PARAMETER :: I_CH3SO3m_as = 5 
      INTEGER, PARAMETER :: I_IO3m_cs = 6 
      INTEGER, PARAMETER :: I_CH3SO3m_cs = 7 
      INTEGER, PARAMETER :: I_DMSO_as = 8 
      INTEGER, PARAMETER :: I_DMSO_cs = 9 
      INTEGER, PARAMETER :: I_Cl2O2 = 10 
      INTEGER, PARAMETER :: I_CH3Br = 11 
      INTEGER, PARAMETER :: I_C3H7I = 12 
      INTEGER, PARAMETER :: I_NH3 = 13 
      INTEGER, PARAMETER :: I_OClO = 14 
      INTEGER, PARAMETER :: I_HIO3 = 15 
      INTEGER, PARAMETER :: I_H2SO4 = 16 
      INTEGER, PARAMETER :: I_O2_as = 17 
      INTEGER, PARAMETER :: I_IO_as = 18 
      INTEGER, PARAMETER :: I_NH4p_as = 19 
      INTEGER, PARAMETER :: I_NH3_as = 20 
      INTEGER, PARAMETER :: I_ICl2m_as = 21 
      INTEGER, PARAMETER :: I_IBr2m_as = 22 
      INTEGER, PARAMETER :: I_O2_cs = 23 
      INTEGER, PARAMETER :: I_IO_cs = 24 
      INTEGER, PARAMETER :: I_NH4p_cs = 25 
      INTEGER, PARAMETER :: I_NH3_cs = 26 
      INTEGER, PARAMETER :: I_ICl2m_cs = 27 
      INTEGER, PARAMETER :: I_IBr2m_cs = 28 
      INTEGER, PARAMETER :: I_H = 29 
      INTEGER, PARAMETER :: I_ClNO2 = 30 
      INTEGER, PARAMETER :: I_BrNO2 = 31 
      INTEGER, PARAMETER :: I_O1D = 32 
      INTEGER, PARAMETER :: I_CH3SO3 = 33 
      INTEGER, PARAMETER :: I_CH3OH = 34 
      INTEGER, PARAMETER :: I_NO4m_as = 35 
      INTEGER, PARAMETER :: I_NO4m_cs = 36 
      INTEGER, PARAMETER :: I_H2 = 37 
      INTEGER, PARAMETER :: I_O3P = 38 
      INTEGER, PARAMETER :: I_ICl = 39 
      INTEGER, PARAMETER :: I_IBr = 40 
      INTEGER, PARAMETER :: I_H2SO4_as = 41 
      INTEGER, PARAMETER :: I_BrCl2m_as = 42 
      INTEGER, PARAMETER :: I_SO3m_as = 43 
      INTEGER, PARAMETER :: I_H2SO4_cs = 44 
      INTEGER, PARAMETER :: I_BrCl2m_cs = 45 
      INTEGER, PARAMETER :: I_SO3m_cs = 46 
      INTEGER, PARAMETER :: I_HCl_as = 47 
      INTEGER, PARAMETER :: I_HBr_as = 48 
      INTEGER, PARAMETER :: I_SO2_as = 49 
      INTEGER, PARAMETER :: I_HCl_cs = 50 
      INTEGER, PARAMETER :: I_HBr_cs = 51 
      INTEGER, PARAMETER :: I_SO2_cs = 52 
      INTEGER, PARAMETER :: I_CH3SO3H = 53 
      INTEGER, PARAMETER :: I_CO2_as = 54 
      INTEGER, PARAMETER :: I_CH4 = 55 
      INTEGER, PARAMETER :: I_CO = 56 
      INTEGER, PARAMETER :: I_CO2_cs = 57 
      INTEGER, PARAMETER :: I_CH3OH_as = 58 
      INTEGER, PARAMETER :: I_CH2OHSO3m_as = 59 
      INTEGER, PARAMETER :: I_CH3OH_cs = 60 
      INTEGER, PARAMETER :: I_INO2 = 61 
      INTEGER, PARAMETER :: I_HCOOH = 62 
      INTEGER, PARAMETER :: I_CH2OHSO3m_cs = 63 
      INTEGER, PARAMETER :: I_BrOHm_as = 64 
      INTEGER, PARAMETER :: I_BrOHm_cs = 65 
      INTEGER, PARAMETER :: I_I2O2 = 66 
      INTEGER, PARAMETER :: I_ClOHm_as = 67 
      INTEGER, PARAMETER :: I_Br2Clm_as = 68 
      INTEGER, PARAMETER :: I_ClOHm_cs = 69 
      INTEGER, PARAMETER :: I_Br2Clm_cs = 70 
      INTEGER, PARAMETER :: I_HOCl = 71 
      INTEGER, PARAMETER :: I_Br_as = 72 
      INTEGER, PARAMETER :: I_Br_cs = 73 
      INTEGER, PARAMETER :: I_HOBr = 74 
      INTEGER, PARAMETER :: I_I2 = 75 
      INTEGER, PARAMETER :: I_HI = 76 
      INTEGER, PARAMETER :: I_HCO3m_as = 77 
      INTEGER, PARAMETER :: I_HCO3m_cs = 78 
      INTEGER, PARAMETER :: I_HSO4m_as = 79 
      INTEGER, PARAMETER :: I_HSO4m_cs = 80 
      INTEGER, PARAMETER :: I_HOI = 81 
      INTEGER, PARAMETER :: I_HCOOm_as = 82 
      INTEGER, PARAMETER :: I_HONO = 83 
      INTEGER, PARAMETER :: I_HCOOm_cs = 84 
      INTEGER, PARAMETER :: I_ClOm_as = 85 
      INTEGER, PARAMETER :: I_BrOm_as = 86 
      INTEGER, PARAMETER :: I_ClOm_cs = 87 
      INTEGER, PARAMETER :: I_BrOm_cs = 88 
      INTEGER, PARAMETER :: I_DMSO = 89 
      INTEGER, PARAMETER :: I_Cl2 = 90 
      INTEGER, PARAMETER :: I_HNO3_cs = 91 
      INTEGER, PARAMETER :: I_HNO4_cs = 92 
      INTEGER, PARAMETER :: I_HNO3_as = 93 
      INTEGER, PARAMETER :: I_HNO4_as = 94 
      INTEGER, PARAMETER :: I_H2O = 95 
      INTEGER, PARAMETER :: I_Br2 = 96 
      INTEGER, PARAMETER :: I_CO3m_as = 97 
      INTEGER, PARAMETER :: I_CH3O2_cs = 98 
      INTEGER, PARAMETER :: I_H2O2 = 99 
      INTEGER, PARAMETER :: I_CO3m_cs = 100 
      INTEGER, PARAMETER :: I_CH3O2_as = 101 
      INTEGER, PARAMETER :: I_CH3SO2 = 102 
      INTEGER, PARAMETER :: I_HCHO_as = 103 
      INTEGER, PARAMETER :: I_HCHO_cs = 104 
      INTEGER, PARAMETER :: I_INO3 = 105 
      INTEGER, PARAMETER :: I_IO2m_as = 106 
      INTEGER, PARAMETER :: I_HSO5m_as = 107 
      INTEGER, PARAMETER :: I_IO2m_cs = 108 
      INTEGER, PARAMETER :: I_HSO5m_cs = 109 
      INTEGER, PARAMETER :: I_IBr_as = 110 
      INTEGER, PARAMETER :: I_ICl_cs = 111 
      INTEGER, PARAMETER :: I_BrCl_as = 112 
      INTEGER, PARAMETER :: I_BrCl_cs = 113 
      INTEGER, PARAMETER :: I_HBr = 114 
      INTEGER, PARAMETER :: I_N2O5 = 115 
      INTEGER, PARAMETER :: I_HCl = 116 
      INTEGER, PARAMETER :: I_SO5m_as = 117 
      INTEGER, PARAMETER :: I_SO5m_cs = 118 
      INTEGER, PARAMETER :: I_SO2 = 119 
      INTEGER, PARAMETER :: I_NO2_cs = 120 
      INTEGER, PARAMETER :: I_HCOOH_cs = 121 
      INTEGER, PARAMETER :: I_NO2_as = 122 
      INTEGER, PARAMETER :: I_I2_as = 123 
      INTEGER, PARAMETER :: I_CH3OOH = 124 
      INTEGER, PARAMETER :: I_OIO = 125 
      INTEGER, PARAMETER :: I_Cl_cs = 126 
      INTEGER, PARAMETER :: I_Cl_as = 127 
      INTEGER, PARAMETER :: I_DMS = 128 
      INTEGER, PARAMETER :: I_BrNO3 = 129 
      INTEGER, PARAMETER :: I_O3_cs = 130 
      INTEGER, PARAMETER :: I_O3_as = 131 
      INTEGER, PARAMETER :: I_ClNO3 = 132 
      INTEGER, PARAMETER :: I_IBr_cs = 133 
      INTEGER, PARAMETER :: I_ICl_as = 134 
      INTEGER, PARAMETER :: I_I2_cs = 135 
      INTEGER, PARAMETER :: I_OHm_as = 136 
      INTEGER, PARAMETER :: I_HONO_cs = 137 
      INTEGER, PARAMETER :: I_Br2_cs = 138 
      INTEGER, PARAMETER :: I_SO4m_cs = 139 
      INTEGER, PARAMETER :: I_SO4m_as = 140 
      INTEGER, PARAMETER :: I_NO3_cs = 141 
      INTEGER, PARAMETER :: I_HNO3 = 142 
      INTEGER, PARAMETER :: I_CH3OOH_cs = 143 
      INTEGER, PARAMETER :: I_HNO4 = 144 
      INTEGER, PARAMETER :: I_Cl2_as = 145 
      INTEGER, PARAMETER :: I_ClO = 146 
      INTEGER, PARAMETER :: I_HONO_as = 147 
      INTEGER, PARAMETER :: I_OHm_cs = 148 
      INTEGER, PARAMETER :: I_NO3_as = 149 
      INTEGER, PARAMETER :: I_BrO = 150 
      INTEGER, PARAMETER :: I_Br2_as = 151 
      INTEGER, PARAMETER :: I_CH3OOH_as = 152 
      INTEGER, PARAMETER :: I_HOI_cs = 153 
      INTEGER, PARAMETER :: I_SO4mm_cs = 154 
      INTEGER, PARAMETER :: I_BrCl = 155 
      INTEGER, PARAMETER :: I_NO3m_cs = 156 
      INTEGER, PARAMETER :: I_NO2m_as = 157 
      INTEGER, PARAMETER :: I_Im_cs = 158 
      INTEGER, PARAMETER :: I_IO = 159 
      INTEGER, PARAMETER :: I_I = 160 
      INTEGER, PARAMETER :: I_SO4mm_as = 161 
      INTEGER, PARAMETER :: I_CH3O2 = 162 
      INTEGER, PARAMETER :: I_NO2m_cs = 163 
      INTEGER, PARAMETER :: I_NO = 164 
      INTEGER, PARAMETER :: I_NO2 = 165 
      INTEGER, PARAMETER :: I_Br = 166 
      INTEGER, PARAMETER :: I_O2m_cs = 167 
      INTEGER, PARAMETER :: I_HCHO = 168 
      INTEGER, PARAMETER :: I_Hp_cs = 169 
      INTEGER, PARAMETER :: I_Cl = 170 
      INTEGER, PARAMETER :: I_Br2m_as = 171 
      INTEGER, PARAMETER :: I_NO3 = 172 
      INTEGER, PARAMETER :: I_H2O2_cs = 173 
      INTEGER, PARAMETER :: I_O2m_as = 174 
      INTEGER, PARAMETER :: I_Clm_as = 175 
      INTEGER, PARAMETER :: I_HCOOH_as = 176 
      INTEGER, PARAMETER :: I_Clm_cs = 177 
      INTEGER, PARAMETER :: I_Cl2m_cs = 178 
      INTEGER, PARAMETER :: I_Hp_as = 179 
      INTEGER, PARAMETER :: I_HO2_as = 180 
      INTEGER, PARAMETER :: I_Brm_cs = 181 
      INTEGER, PARAMETER :: I_Br2m_cs = 182 
      INTEGER, PARAMETER :: I_Cl2_cs = 183 
      INTEGER, PARAMETER :: I_OH_as = 184 
      INTEGER, PARAMETER :: I_OH_cs = 185 
      INTEGER, PARAMETER :: I_H2O2_as = 186 
      INTEGER, PARAMETER :: I_HOCl_cs = 187 
      INTEGER, PARAMETER :: I_HOBr_as = 188 
      INTEGER, PARAMETER :: I_HOBr_cs = 189 
      INTEGER, PARAMETER :: I_HOCl_as = 190 
      INTEGER, PARAMETER :: I_SO3mm_as = 191 
      INTEGER, PARAMETER :: I_SO3mm_cs = 192 
      INTEGER, PARAMETER :: I_Im_as = 193 
      INTEGER, PARAMETER :: I_O3 = 194 
      INTEGER, PARAMETER :: I_NO3m_as = 195 
      INTEGER, PARAMETER :: I_HSO3m_cs = 196 
      INTEGER, PARAMETER :: I_HO2_cs = 197 
      INTEGER, PARAMETER :: I_HSO3m_as = 198 
      INTEGER, PARAMETER :: I_HOI_as = 199 
      INTEGER, PARAMETER :: I_Cl2m_as = 200 
      INTEGER, PARAMETER :: I_Brm_as = 201 
      INTEGER, PARAMETER :: I_OH = 202 
      INTEGER, PARAMETER :: I_HO2 = 203 

! Indexes declaration for radical species                          


! Indexes declaration for fixed species                            

      INTEGER, PARAMETER :: I_O2 = 1 
      INTEGER, PARAMETER :: I_N2 = 2 
      INTEGER, PARAMETER :: I_CO2 = 3 
      INTEGER, PARAMETER :: I_H2O_as = 4 
      INTEGER, PARAMETER :: I_H2O_cs = 5 

! Indexes declaration for dummy species                            

      INTEGER, PARAMETER :: I_N = 0 
      INTEGER, PARAMETER :: I_N2O = 0 
      INTEGER, PARAMETER :: I_C2H6 = 0 
      INTEGER, PARAMETER :: I_C2H4 = 0 
      INTEGER, PARAMETER :: I_EtO2 = 0 
      INTEGER, PARAMETER :: I_EtOOH = 0 
      INTEGER, PARAMETER :: I_CH3CHO = 0 
      INTEGER, PARAMETER :: I_CH3COOH = 0 
      INTEGER, PARAMETER :: I_PA = 0 
      INTEGER, PARAMETER :: I_PAA = 0 
      INTEGER, PARAMETER :: I_NACA = 0 
      INTEGER, PARAMETER :: I_PAN = 0 
      INTEGER, PARAMETER :: I_C3H8 = 0 
      INTEGER, PARAMETER :: I_C3H6 = 0 
      INTEGER, PARAMETER :: I_PrO2 = 0 
      INTEGER, PARAMETER :: I_PrOOH = 0 
      INTEGER, PARAMETER :: I_C3H6O2 = 0 
      INTEGER, PARAMETER :: I_C3H6OOH = 0 
      INTEGER, PARAMETER :: I_CH3COCH3 = 0 
      INTEGER, PARAMETER :: I_ACETO2 = 0 
      INTEGER, PARAMETER :: I_ACETP = 0 
      INTEGER, PARAMETER :: I_ACETOL = 0 
      INTEGER, PARAMETER :: I_CH3COCHO = 0 
      INTEGER, PARAMETER :: I_MPAN = 0 
      INTEGER, PARAMETER :: I_PrONO2 = 0 
      INTEGER, PARAMETER :: I_C4H10 = 0 
      INTEGER, PARAMETER :: I_C4H9O2 = 0 
      INTEGER, PARAMETER :: I_C4H9OOH = 0 
      INTEGER, PARAMETER :: I_MVK = 0 
      INTEGER, PARAMETER :: I_MVKO2 = 0 
      INTEGER, PARAMETER :: I_MVKOOH = 0 
      INTEGER, PARAMETER :: I_MEK = 0 
      INTEGER, PARAMETER :: I_MEKO2 = 0 
      INTEGER, PARAMETER :: I_MEKOOH = 0 
      INTEGER, PARAMETER :: I_MeCOCO = 0 
      INTEGER, PARAMETER :: I_ONIT = 0 
      INTEGER, PARAMETER :: I_ISOP = 0 
      INTEGER, PARAMETER :: I_ISO2 = 0 
      INTEGER, PARAMETER :: I_ISOOH = 0 
      INTEGER, PARAMETER :: I_ISON = 0 
      INTEGER, PARAMETER :: I_CCl4 = 0 
      INTEGER, PARAMETER :: I_CH3Cl = 0 
      INTEGER, PARAMETER :: I_CH3CCl3 = 0 
      INTEGER, PARAMETER :: I_CF2Cl2 = 0 
      INTEGER, PARAMETER :: I_CFCl3 = 0 
      INTEGER, PARAMETER :: I_CF3Br = 0 
      INTEGER, PARAMETER :: I_CF2ClBr = 0 
      INTEGER, PARAMETER :: I_Dummy = 0 
      INTEGER, PARAMETER :: I_NO_as = 0 
      INTEGER, PARAMETER :: I_N2O5_as = 0 
      INTEGER, PARAMETER :: I_CH3COOH_as = 0 
      INTEGER, PARAMETER :: I_PAN_as = 0 
      INTEGER, PARAMETER :: I_EtO2_as = 0 
      INTEGER, PARAMETER :: I_CH3CHO_as = 0 
      INTEGER, PARAMETER :: I_CH3COCH3_as = 0 
      INTEGER, PARAMETER :: I_HI_as = 0 
      INTEGER, PARAMETER :: I_HIO3_as = 0 
      INTEGER, PARAMETER :: I_CH3COOm_as = 0 
      INTEGER, PARAMETER :: I_IClBrm_as = 0 
      INTEGER, PARAMETER :: I_D1O_as = 0 
      INTEGER, PARAMETER :: I_D2O_as = 0 
      INTEGER, PARAMETER :: I_DAHp_as = 0 
      INTEGER, PARAMETER :: I_DA_as = 0 
      INTEGER, PARAMETER :: I_DAm_as = 0 
      INTEGER, PARAMETER :: I_DGtAi_as = 0 
      INTEGER, PARAMETER :: I_DGtAs_as = 0 
      INTEGER, PARAMETER :: I_PROD1_as = 0 
      INTEGER, PARAMETER :: I_PROD2_as = 0 
      INTEGER, PARAMETER :: I_Nap_as = 0 
      INTEGER, PARAMETER :: I_NO_cs = 0 
      INTEGER, PARAMETER :: I_N2O5_cs = 0 
      INTEGER, PARAMETER :: I_CH3COOH_cs = 0 
      INTEGER, PARAMETER :: I_PAN_cs = 0 
      INTEGER, PARAMETER :: I_EtO2_cs = 0 
      INTEGER, PARAMETER :: I_CH3CHO_cs = 0 
      INTEGER, PARAMETER :: I_CH3COCH3_cs = 0 
      INTEGER, PARAMETER :: I_HI_cs = 0 
      INTEGER, PARAMETER :: I_HIO3_cs = 0 
      INTEGER, PARAMETER :: I_CH3COOm_cs = 0 
      INTEGER, PARAMETER :: I_IClBrm_cs = 0 
      INTEGER, PARAMETER :: I_D1O_cs = 0 
      INTEGER, PARAMETER :: I_D2O_cs = 0 
      INTEGER, PARAMETER :: I_DAHp_cs = 0 
      INTEGER, PARAMETER :: I_DA_cs = 0 
      INTEGER, PARAMETER :: I_DAm_cs = 0 
      INTEGER, PARAMETER :: I_DGtAi_cs = 0 
      INTEGER, PARAMETER :: I_DGtAs_cs = 0 
      INTEGER, PARAMETER :: I_PROD1_cs = 0 
      INTEGER, PARAMETER :: I_PROD2_cs = 0 
      INTEGER, PARAMETER :: I_Nap_cs = 0 
      INTEGER, PARAMETER :: I_O2_l = 0 
      INTEGER, PARAMETER :: I_O3_l = 0 
      INTEGER, PARAMETER :: I_OH_l = 0 
      INTEGER, PARAMETER :: I_HO2_l = 0 
      INTEGER, PARAMETER :: I_H2O_l = 0 
      INTEGER, PARAMETER :: I_H2O2_l = 0 
      INTEGER, PARAMETER :: I_NH3_l = 0 
      INTEGER, PARAMETER :: I_NO_l = 0 
      INTEGER, PARAMETER :: I_NO2_l = 0 
      INTEGER, PARAMETER :: I_NO3_l = 0 
      INTEGER, PARAMETER :: I_HONO_l = 0 
      INTEGER, PARAMETER :: I_HNO3_l = 0 
      INTEGER, PARAMETER :: I_HNO4_l = 0 
      INTEGER, PARAMETER :: I_N2O5_l = 0 
      INTEGER, PARAMETER :: I_CH3OH_l = 0 
      INTEGER, PARAMETER :: I_HCOOH_l = 0 
      INTEGER, PARAMETER :: I_HCHO_l = 0 
      INTEGER, PARAMETER :: I_CH3O2_l = 0 
      INTEGER, PARAMETER :: I_CH3OOH_l = 0 
      INTEGER, PARAMETER :: I_CO2_l = 0 
      INTEGER, PARAMETER :: I_CH3COOH_l = 0 
      INTEGER, PARAMETER :: I_PAN_l = 0 
      INTEGER, PARAMETER :: I_EtO2_l = 0 
      INTEGER, PARAMETER :: I_CH3CHO_l = 0 
      INTEGER, PARAMETER :: I_CH3COCH3_l = 0 
      INTEGER, PARAMETER :: I_Cl_l = 0 
      INTEGER, PARAMETER :: I_Cl2_l = 0 
      INTEGER, PARAMETER :: I_HCl_l = 0 
      INTEGER, PARAMETER :: I_HOCl_l = 0 
      INTEGER, PARAMETER :: I_Br_l = 0 
      INTEGER, PARAMETER :: I_Br2_l = 0 
      INTEGER, PARAMETER :: I_HBr_l = 0 
      INTEGER, PARAMETER :: I_HOBr_l = 0 
      INTEGER, PARAMETER :: I_BrCl_l = 0 
      INTEGER, PARAMETER :: I_I2_l = 0 
      INTEGER, PARAMETER :: I_IO_l = 0 
      INTEGER, PARAMETER :: I_HI_l = 0 
      INTEGER, PARAMETER :: I_HOI_l = 0 
      INTEGER, PARAMETER :: I_ICl_l = 0 
      INTEGER, PARAMETER :: I_IBr_l = 0 
      INTEGER, PARAMETER :: I_HIO3_l = 0 
      INTEGER, PARAMETER :: I_SO2_l = 0 
      INTEGER, PARAMETER :: I_H2SO4_l = 0 
      INTEGER, PARAMETER :: I_DMSO_l = 0 
      INTEGER, PARAMETER :: I_O2m_l = 0 
      INTEGER, PARAMETER :: I_OHm_l = 0 
      INTEGER, PARAMETER :: I_Hp_l = 0 
      INTEGER, PARAMETER :: I_NH4p_l = 0 
      INTEGER, PARAMETER :: I_NO2m_l = 0 
      INTEGER, PARAMETER :: I_NO3m_l = 0 
      INTEGER, PARAMETER :: I_NO4m_l = 0 
      INTEGER, PARAMETER :: I_CO3m_l = 0 
      INTEGER, PARAMETER :: I_HCOOm_l = 0 
      INTEGER, PARAMETER :: I_HCO3m_l = 0 
      INTEGER, PARAMETER :: I_CH3COOm_l = 0 
      INTEGER, PARAMETER :: I_Clm_l = 0 
      INTEGER, PARAMETER :: I_Cl2m_l = 0 
      INTEGER, PARAMETER :: I_ClOm_l = 0 
      INTEGER, PARAMETER :: I_ClOHm_l = 0 
      INTEGER, PARAMETER :: I_Brm_l = 0 
      INTEGER, PARAMETER :: I_Br2m_l = 0 
      INTEGER, PARAMETER :: I_BrOm_l = 0 
      INTEGER, PARAMETER :: I_BrOHm_l = 0 
      INTEGER, PARAMETER :: I_BrCl2m_l = 0 
      INTEGER, PARAMETER :: I_Br2Clm_l = 0 
      INTEGER, PARAMETER :: I_Im_l = 0 
      INTEGER, PARAMETER :: I_IO2m_l = 0 
      INTEGER, PARAMETER :: I_IO3m_l = 0 
      INTEGER, PARAMETER :: I_ICl2m_l = 0 
      INTEGER, PARAMETER :: I_IClBrm_l = 0 
      INTEGER, PARAMETER :: I_IBr2m_l = 0 
      INTEGER, PARAMETER :: I_SO3m_l = 0 
      INTEGER, PARAMETER :: I_SO3mm_l = 0 
      INTEGER, PARAMETER :: I_SO4m_l = 0 
      INTEGER, PARAMETER :: I_SO4mm_l = 0 
      INTEGER, PARAMETER :: I_SO5m_l = 0 
      INTEGER, PARAMETER :: I_HSO3m_l = 0 
      INTEGER, PARAMETER :: I_HSO4m_l = 0 
      INTEGER, PARAMETER :: I_HSO5m_l = 0 
      INTEGER, PARAMETER :: I_CH3SO3m_l = 0 
      INTEGER, PARAMETER :: I_CH2OHSO3m_l = 0 
      INTEGER, PARAMETER :: I_D1O_l = 0 
      INTEGER, PARAMETER :: I_D2O_l = 0 
      INTEGER, PARAMETER :: I_DAHp_l = 0 
      INTEGER, PARAMETER :: I_DA_l = 0 
      INTEGER, PARAMETER :: I_DAm_l = 0 
      INTEGER, PARAMETER :: I_DGtAi_l = 0 
      INTEGER, PARAMETER :: I_DGtAs_l = 0 
      INTEGER, PARAMETER :: I_PROD1_l = 0 
      INTEGER, PARAMETER :: I_PROD2_l = 0 
      INTEGER, PARAMETER :: I_Nap_l = 0 

! Indexes KPP_ for variable species                                

      INTEGER, PARAMETER :: KPP_CH3I = 1 
      INTEGER, PARAMETER :: KPP_CH2I2 = 2 
      INTEGER, PARAMETER :: KPP_CH2ClI = 3 
      INTEGER, PARAMETER :: KPP_IO3m_as = 4 
      INTEGER, PARAMETER :: KPP_CH3SO3m_as = 5 
      INTEGER, PARAMETER :: KPP_IO3m_cs = 6 
      INTEGER, PARAMETER :: KPP_CH3SO3m_cs = 7 
      INTEGER, PARAMETER :: KPP_DMSO_as = 8 
      INTEGER, PARAMETER :: KPP_DMSO_cs = 9 
      INTEGER, PARAMETER :: KPP_Cl2O2 = 10 
      INTEGER, PARAMETER :: KPP_CH3Br = 11 
      INTEGER, PARAMETER :: KPP_C3H7I = 12 
      INTEGER, PARAMETER :: KPP_NH3 = 13 
      INTEGER, PARAMETER :: KPP_OClO = 14 
      INTEGER, PARAMETER :: KPP_HIO3 = 15 
      INTEGER, PARAMETER :: KPP_H2SO4 = 16 
      INTEGER, PARAMETER :: KPP_O2_as = 17 
      INTEGER, PARAMETER :: KPP_IO_as = 18 
      INTEGER, PARAMETER :: KPP_NH4p_as = 19 
      INTEGER, PARAMETER :: KPP_NH3_as = 20 
      INTEGER, PARAMETER :: KPP_ICl2m_as = 21 
      INTEGER, PARAMETER :: KPP_IBr2m_as = 22 
      INTEGER, PARAMETER :: KPP_O2_cs = 23 
      INTEGER, PARAMETER :: KPP_IO_cs = 24 
      INTEGER, PARAMETER :: KPP_NH4p_cs = 25 
      INTEGER, PARAMETER :: KPP_NH3_cs = 26 
      INTEGER, PARAMETER :: KPP_ICl2m_cs = 27 
      INTEGER, PARAMETER :: KPP_IBr2m_cs = 28 
      INTEGER, PARAMETER :: KPP_H = 29 
      INTEGER, PARAMETER :: KPP_ClNO2 = 30 
      INTEGER, PARAMETER :: KPP_BrNO2 = 31 
      INTEGER, PARAMETER :: KPP_O1D = 32 
      INTEGER, PARAMETER :: KPP_CH3SO3 = 33 
      INTEGER, PARAMETER :: KPP_CH3OH = 34 
      INTEGER, PARAMETER :: KPP_NO4m_as = 35 
      INTEGER, PARAMETER :: KPP_NO4m_cs = 36 
      INTEGER, PARAMETER :: KPP_H2 = 37 
      INTEGER, PARAMETER :: KPP_O3P = 38 
      INTEGER, PARAMETER :: KPP_ICl = 39 
      INTEGER, PARAMETER :: KPP_IBr = 40 
      INTEGER, PARAMETER :: KPP_H2SO4_as = 41 
      INTEGER, PARAMETER :: KPP_BrCl2m_as = 42 
      INTEGER, PARAMETER :: KPP_SO3m_as = 43 
      INTEGER, PARAMETER :: KPP_H2SO4_cs = 44 
      INTEGER, PARAMETER :: KPP_BrCl2m_cs = 45 
      INTEGER, PARAMETER :: KPP_SO3m_cs = 46 
      INTEGER, PARAMETER :: KPP_HCl_as = 47 
      INTEGER, PARAMETER :: KPP_HBr_as = 48 
      INTEGER, PARAMETER :: KPP_SO2_as = 49 
      INTEGER, PARAMETER :: KPP_HCl_cs = 50 
      INTEGER, PARAMETER :: KPP_HBr_cs = 51 
      INTEGER, PARAMETER :: KPP_SO2_cs = 52 
      INTEGER, PARAMETER :: KPP_CH3SO3H = 53 
      INTEGER, PARAMETER :: KPP_CO2_as = 54 
      INTEGER, PARAMETER :: KPP_CH4 = 55 
      INTEGER, PARAMETER :: KPP_CO = 56 
      INTEGER, PARAMETER :: KPP_CO2_cs = 57 
      INTEGER, PARAMETER :: KPP_CH3OH_as = 58 
      INTEGER, PARAMETER :: KPP_CH2OHSO3m_as = 59 
      INTEGER, PARAMETER :: KPP_CH3OH_cs = 60 
      INTEGER, PARAMETER :: KPP_INO2 = 61 
      INTEGER, PARAMETER :: KPP_HCOOH = 62 
      INTEGER, PARAMETER :: KPP_CH2OHSO3m_cs = 63 
      INTEGER, PARAMETER :: KPP_BrOHm_as = 64 
      INTEGER, PARAMETER :: KPP_BrOHm_cs = 65 
      INTEGER, PARAMETER :: KPP_I2O2 = 66 
      INTEGER, PARAMETER :: KPP_ClOHm_as = 67 
      INTEGER, PARAMETER :: KPP_Br2Clm_as = 68 
      INTEGER, PARAMETER :: KPP_ClOHm_cs = 69 
      INTEGER, PARAMETER :: KPP_Br2Clm_cs = 70 
      INTEGER, PARAMETER :: KPP_HOCl = 71 
      INTEGER, PARAMETER :: KPP_Br_as = 72 
      INTEGER, PARAMETER :: KPP_Br_cs = 73 
      INTEGER, PARAMETER :: KPP_HOBr = 74 
      INTEGER, PARAMETER :: KPP_I2 = 75 
      INTEGER, PARAMETER :: KPP_HI = 76 
      INTEGER, PARAMETER :: KPP_HCO3m_as = 77 
      INTEGER, PARAMETER :: KPP_HCO3m_cs = 78 
      INTEGER, PARAMETER :: KPP_HSO4m_as = 79 
      INTEGER, PARAMETER :: KPP_HSO4m_cs = 80 
      INTEGER, PARAMETER :: KPP_HOI = 81 
      INTEGER, PARAMETER :: KPP_HCOOm_as = 82 
      INTEGER, PARAMETER :: KPP_HONO = 83 
      INTEGER, PARAMETER :: KPP_HCOOm_cs = 84 
      INTEGER, PARAMETER :: KPP_ClOm_as = 85 
      INTEGER, PARAMETER :: KPP_BrOm_as = 86 
      INTEGER, PARAMETER :: KPP_ClOm_cs = 87 
      INTEGER, PARAMETER :: KPP_BrOm_cs = 88 
      INTEGER, PARAMETER :: KPP_DMSO = 89 
      INTEGER, PARAMETER :: KPP_Cl2 = 90 
      INTEGER, PARAMETER :: KPP_HNO3_cs = 91 
      INTEGER, PARAMETER :: KPP_HNO4_cs = 92 
      INTEGER, PARAMETER :: KPP_HNO3_as = 93 
      INTEGER, PARAMETER :: KPP_HNO4_as = 94 
      INTEGER, PARAMETER :: KPP_H2O = 95 
      INTEGER, PARAMETER :: KPP_Br2 = 96 
      INTEGER, PARAMETER :: KPP_CO3m_as = 97 
      INTEGER, PARAMETER :: KPP_CH3O2_cs = 98 
      INTEGER, PARAMETER :: KPP_H2O2 = 99 
      INTEGER, PARAMETER :: KPP_CO3m_cs = 100 
      INTEGER, PARAMETER :: KPP_CH3O2_as = 101 
      INTEGER, PARAMETER :: KPP_CH3SO2 = 102 
      INTEGER, PARAMETER :: KPP_HCHO_as = 103 
      INTEGER, PARAMETER :: KPP_HCHO_cs = 104 
      INTEGER, PARAMETER :: KPP_INO3 = 105 
      INTEGER, PARAMETER :: KPP_IO2m_as = 106 
      INTEGER, PARAMETER :: KPP_HSO5m_as = 107 
      INTEGER, PARAMETER :: KPP_IO2m_cs = 108 
      INTEGER, PARAMETER :: KPP_HSO5m_cs = 109 
      INTEGER, PARAMETER :: KPP_IBr_as = 110 
      INTEGER, PARAMETER :: KPP_ICl_cs = 111 
      INTEGER, PARAMETER :: KPP_BrCl_as = 112 
      INTEGER, PARAMETER :: KPP_BrCl_cs = 113 
      INTEGER, PARAMETER :: KPP_HBr = 114 
      INTEGER, PARAMETER :: KPP_N2O5 = 115 
      INTEGER, PARAMETER :: KPP_HCl = 116 
      INTEGER, PARAMETER :: KPP_SO5m_as = 117 
      INTEGER, PARAMETER :: KPP_SO5m_cs = 118 
      INTEGER, PARAMETER :: KPP_SO2 = 119 
      INTEGER, PARAMETER :: KPP_NO2_cs = 120 
      INTEGER, PARAMETER :: KPP_HCOOH_cs = 121 
      INTEGER, PARAMETER :: KPP_NO2_as = 122 
      INTEGER, PARAMETER :: KPP_I2_as = 123 
      INTEGER, PARAMETER :: KPP_CH3OOH = 124 
      INTEGER, PARAMETER :: KPP_OIO = 125 
      INTEGER, PARAMETER :: KPP_Cl_cs = 126 
      INTEGER, PARAMETER :: KPP_Cl_as = 127 
      INTEGER, PARAMETER :: KPP_DMS = 128 
      INTEGER, PARAMETER :: KPP_BrNO3 = 129 
      INTEGER, PARAMETER :: KPP_O3_cs = 130 
      INTEGER, PARAMETER :: KPP_O3_as = 131 
      INTEGER, PARAMETER :: KPP_ClNO3 = 132 
      INTEGER, PARAMETER :: KPP_IBr_cs = 133 
      INTEGER, PARAMETER :: KPP_ICl_as = 134 
      INTEGER, PARAMETER :: KPP_I2_cs = 135 
      INTEGER, PARAMETER :: KPP_OHm_as = 136 
      INTEGER, PARAMETER :: KPP_HONO_cs = 137 
      INTEGER, PARAMETER :: KPP_Br2_cs = 138 
      INTEGER, PARAMETER :: KPP_SO4m_cs = 139 
      INTEGER, PARAMETER :: KPP_SO4m_as = 140 
      INTEGER, PARAMETER :: KPP_NO3_cs = 141 
      INTEGER, PARAMETER :: KPP_HNO3 = 142 
      INTEGER, PARAMETER :: KPP_CH3OOH_cs = 143 
      INTEGER, PARAMETER :: KPP_HNO4 = 144 
      INTEGER, PARAMETER :: KPP_Cl2_as = 145 
      INTEGER, PARAMETER :: KPP_ClO = 146 
      INTEGER, PARAMETER :: KPP_HONO_as = 147 
      INTEGER, PARAMETER :: KPP_OHm_cs = 148 
      INTEGER, PARAMETER :: KPP_NO3_as = 149 
      INTEGER, PARAMETER :: KPP_BrO = 150 
      INTEGER, PARAMETER :: KPP_Br2_as = 151 
      INTEGER, PARAMETER :: KPP_CH3OOH_as = 152 
      INTEGER, PARAMETER :: KPP_HOI_cs = 153 
      INTEGER, PARAMETER :: KPP_SO4mm_cs = 154 
      INTEGER, PARAMETER :: KPP_BrCl = 155 
      INTEGER, PARAMETER :: KPP_NO3m_cs = 156 
      INTEGER, PARAMETER :: KPP_NO2m_as = 157 
      INTEGER, PARAMETER :: KPP_Im_cs = 158 
      INTEGER, PARAMETER :: KPP_IO = 159 
      INTEGER, PARAMETER :: KPP_I = 160 
      INTEGER, PARAMETER :: KPP_SO4mm_as = 161 
      INTEGER, PARAMETER :: KPP_CH3O2 = 162 
      INTEGER, PARAMETER :: KPP_NO2m_cs = 163 
      INTEGER, PARAMETER :: KPP_NO = 164 
      INTEGER, PARAMETER :: KPP_NO2 = 165 
      INTEGER, PARAMETER :: KPP_Br = 166 
      INTEGER, PARAMETER :: KPP_O2m_cs = 167 
      INTEGER, PARAMETER :: KPP_HCHO = 168 
      INTEGER, PARAMETER :: KPP_Hp_cs = 169 
      INTEGER, PARAMETER :: KPP_Cl = 170 
      INTEGER, PARAMETER :: KPP_Br2m_as = 171 
      INTEGER, PARAMETER :: KPP_NO3 = 172 
      INTEGER, PARAMETER :: KPP_H2O2_cs = 173 
      INTEGER, PARAMETER :: KPP_O2m_as = 174 
      INTEGER, PARAMETER :: KPP_Clm_as = 175 
      INTEGER, PARAMETER :: KPP_HCOOH_as = 176 
      INTEGER, PARAMETER :: KPP_Clm_cs = 177 
      INTEGER, PARAMETER :: KPP_Cl2m_cs = 178 
      INTEGER, PARAMETER :: KPP_Hp_as = 179 
      INTEGER, PARAMETER :: KPP_HO2_as = 180 
      INTEGER, PARAMETER :: KPP_Brm_cs = 181 
      INTEGER, PARAMETER :: KPP_Br2m_cs = 182 
      INTEGER, PARAMETER :: KPP_Cl2_cs = 183 
      INTEGER, PARAMETER :: KPP_OH_as = 184 
      INTEGER, PARAMETER :: KPP_OH_cs = 185 
      INTEGER, PARAMETER :: KPP_H2O2_as = 186 
      INTEGER, PARAMETER :: KPP_HOCl_cs = 187 
      INTEGER, PARAMETER :: KPP_HOBr_as = 188 
      INTEGER, PARAMETER :: KPP_HOBr_cs = 189 
      INTEGER, PARAMETER :: KPP_HOCl_as = 190 
      INTEGER, PARAMETER :: KPP_SO3mm_as = 191 
      INTEGER, PARAMETER :: KPP_SO3mm_cs = 192 
      INTEGER, PARAMETER :: KPP_Im_as = 193 
      INTEGER, PARAMETER :: KPP_O3 = 194 
      INTEGER, PARAMETER :: KPP_NO3m_as = 195 
      INTEGER, PARAMETER :: KPP_HSO3m_cs = 196 
      INTEGER, PARAMETER :: KPP_HO2_cs = 197 
      INTEGER, PARAMETER :: KPP_HSO3m_as = 198 
      INTEGER, PARAMETER :: KPP_HOI_as = 199 
      INTEGER, PARAMETER :: KPP_Cl2m_as = 200 
      INTEGER, PARAMETER :: KPP_Brm_as = 201 
      INTEGER, PARAMETER :: KPP_OH = 202 
      INTEGER, PARAMETER :: KPP_HO2 = 203 

! Indexes KPP_ for radical species                                 


! Indexes KPP_ for fixed species                                   

      INTEGER, PARAMETER :: KPP_O2 = 204 
      INTEGER, PARAMETER :: KPP_N2 = 205 
      INTEGER, PARAMETER :: KPP_CO2 = 206 
      INTEGER, PARAMETER :: KPP_H2O_as = 207 
      INTEGER, PARAMETER :: KPP_H2O_cs = 208 

! Indexes KPP_ for dummy species                                   

      INTEGER, PARAMETER :: KPP_N = 0 
      INTEGER, PARAMETER :: KPP_N2O = 0 
      INTEGER, PARAMETER :: KPP_C2H6 = 0 
      INTEGER, PARAMETER :: KPP_C2H4 = 0 
      INTEGER, PARAMETER :: KPP_EtO2 = 0 
      INTEGER, PARAMETER :: KPP_EtOOH = 0 
      INTEGER, PARAMETER :: KPP_CH3CHO = 0 
      INTEGER, PARAMETER :: KPP_CH3COOH = 0 
      INTEGER, PARAMETER :: KPP_PA = 0 
      INTEGER, PARAMETER :: KPP_PAA = 0 
      INTEGER, PARAMETER :: KPP_NACA = 0 
      INTEGER, PARAMETER :: KPP_PAN = 0 
      INTEGER, PARAMETER :: KPP_C3H8 = 0 
      INTEGER, PARAMETER :: KPP_C3H6 = 0 
      INTEGER, PARAMETER :: KPP_PrO2 = 0 
      INTEGER, PARAMETER :: KPP_PrOOH = 0 
      INTEGER, PARAMETER :: KPP_C3H6O2 = 0 
      INTEGER, PARAMETER :: KPP_C3H6OOH = 0 
      INTEGER, PARAMETER :: KPP_CH3COCH3 = 0 
      INTEGER, PARAMETER :: KPP_ACETO2 = 0 
      INTEGER, PARAMETER :: KPP_ACETP = 0 
      INTEGER, PARAMETER :: KPP_ACETOL = 0 
      INTEGER, PARAMETER :: KPP_CH3COCHO = 0 
      INTEGER, PARAMETER :: KPP_MPAN = 0 
      INTEGER, PARAMETER :: KPP_PrONO2 = 0 
      INTEGER, PARAMETER :: KPP_C4H10 = 0 
      INTEGER, PARAMETER :: KPP_C4H9O2 = 0 
      INTEGER, PARAMETER :: KPP_C4H9OOH = 0 
      INTEGER, PARAMETER :: KPP_MVK = 0 
      INTEGER, PARAMETER :: KPP_MVKO2 = 0 
      INTEGER, PARAMETER :: KPP_MVKOOH = 0 
      INTEGER, PARAMETER :: KPP_MEK = 0 
      INTEGER, PARAMETER :: KPP_MEKO2 = 0 
      INTEGER, PARAMETER :: KPP_MEKOOH = 0 
      INTEGER, PARAMETER :: KPP_MeCOCO = 0 
      INTEGER, PARAMETER :: KPP_ONIT = 0 
      INTEGER, PARAMETER :: KPP_ISOP = 0 
      INTEGER, PARAMETER :: KPP_ISO2 = 0 
      INTEGER, PARAMETER :: KPP_ISOOH = 0 
      INTEGER, PARAMETER :: KPP_ISON = 0 
      INTEGER, PARAMETER :: KPP_CCl4 = 0 
      INTEGER, PARAMETER :: KPP_CH3Cl = 0 
      INTEGER, PARAMETER :: KPP_CH3CCl3 = 0 
      INTEGER, PARAMETER :: KPP_CF2Cl2 = 0 
      INTEGER, PARAMETER :: KPP_CFCl3 = 0 
      INTEGER, PARAMETER :: KPP_CF3Br = 0 
      INTEGER, PARAMETER :: KPP_CF2ClBr = 0 
      INTEGER, PARAMETER :: KPP_Dummy = 0 
      INTEGER, PARAMETER :: KPP_NO_as = 0 
      INTEGER, PARAMETER :: KPP_N2O5_as = 0 
      INTEGER, PARAMETER :: KPP_CH3COOH_as = 0 
      INTEGER, PARAMETER :: KPP_PAN_as = 0 
      INTEGER, PARAMETER :: KPP_EtO2_as = 0 
      INTEGER, PARAMETER :: KPP_CH3CHO_as = 0 
      INTEGER, PARAMETER :: KPP_CH3COCH3_as = 0 
      INTEGER, PARAMETER :: KPP_HI_as = 0 
      INTEGER, PARAMETER :: KPP_HIO3_as = 0 
      INTEGER, PARAMETER :: KPP_CH3COOm_as = 0 
      INTEGER, PARAMETER :: KPP_IClBrm_as = 0 
      INTEGER, PARAMETER :: KPP_D1O_as = 0 
      INTEGER, PARAMETER :: KPP_D2O_as = 0 
      INTEGER, PARAMETER :: KPP_DAHp_as = 0 
      INTEGER, PARAMETER :: KPP_DA_as = 0 
      INTEGER, PARAMETER :: KPP_DAm_as = 0 
      INTEGER, PARAMETER :: KPP_DGtAi_as = 0 
      INTEGER, PARAMETER :: KPP_DGtAs_as = 0 
      INTEGER, PARAMETER :: KPP_PROD1_as = 0 
      INTEGER, PARAMETER :: KPP_PROD2_as = 0 
      INTEGER, PARAMETER :: KPP_Nap_as = 0 
      INTEGER, PARAMETER :: KPP_NO_cs = 0 
      INTEGER, PARAMETER :: KPP_N2O5_cs = 0 
      INTEGER, PARAMETER :: KPP_CH3COOH_cs = 0 
      INTEGER, PARAMETER :: KPP_PAN_cs = 0 
      INTEGER, PARAMETER :: KPP_EtO2_cs = 0 
      INTEGER, PARAMETER :: KPP_CH3CHO_cs = 0 
      INTEGER, PARAMETER :: KPP_CH3COCH3_cs = 0 
      INTEGER, PARAMETER :: KPP_HI_cs = 0 
      INTEGER, PARAMETER :: KPP_HIO3_cs = 0 
      INTEGER, PARAMETER :: KPP_CH3COOm_cs = 0 
      INTEGER, PARAMETER :: KPP_IClBrm_cs = 0 
      INTEGER, PARAMETER :: KPP_D1O_cs = 0 
      INTEGER, PARAMETER :: KPP_D2O_cs = 0 
      INTEGER, PARAMETER :: KPP_DAHp_cs = 0 
      INTEGER, PARAMETER :: KPP_DA_cs = 0 
      INTEGER, PARAMETER :: KPP_DAm_cs = 0 
      INTEGER, PARAMETER :: KPP_DGtAi_cs = 0 
      INTEGER, PARAMETER :: KPP_DGtAs_cs = 0 
      INTEGER, PARAMETER :: KPP_PROD1_cs = 0 
      INTEGER, PARAMETER :: KPP_PROD2_cs = 0 
      INTEGER, PARAMETER :: KPP_Nap_cs = 0 
      INTEGER, PARAMETER :: KPP_O2_l = 0 
      INTEGER, PARAMETER :: KPP_O3_l = 0 
      INTEGER, PARAMETER :: KPP_OH_l = 0 
      INTEGER, PARAMETER :: KPP_HO2_l = 0 
      INTEGER, PARAMETER :: KPP_H2O_l = 0 
      INTEGER, PARAMETER :: KPP_H2O2_l = 0 
      INTEGER, PARAMETER :: KPP_NH3_l = 0 
      INTEGER, PARAMETER :: KPP_NO_l = 0 
      INTEGER, PARAMETER :: KPP_NO2_l = 0 
      INTEGER, PARAMETER :: KPP_NO3_l = 0 
      INTEGER, PARAMETER :: KPP_HONO_l = 0 
      INTEGER, PARAMETER :: KPP_HNO3_l = 0 
      INTEGER, PARAMETER :: KPP_HNO4_l = 0 
      INTEGER, PARAMETER :: KPP_N2O5_l = 0 
      INTEGER, PARAMETER :: KPP_CH3OH_l = 0 
      INTEGER, PARAMETER :: KPP_HCOOH_l = 0 
      INTEGER, PARAMETER :: KPP_HCHO_l = 0 
      INTEGER, PARAMETER :: KPP_CH3O2_l = 0 
      INTEGER, PARAMETER :: KPP_CH3OOH_l = 0 
      INTEGER, PARAMETER :: KPP_CO2_l = 0 
      INTEGER, PARAMETER :: KPP_CH3COOH_l = 0 
      INTEGER, PARAMETER :: KPP_PAN_l = 0 
      INTEGER, PARAMETER :: KPP_EtO2_l = 0 
      INTEGER, PARAMETER :: KPP_CH3CHO_l = 0 
      INTEGER, PARAMETER :: KPP_CH3COCH3_l = 0 
      INTEGER, PARAMETER :: KPP_Cl_l = 0 
      INTEGER, PARAMETER :: KPP_Cl2_l = 0 
      INTEGER, PARAMETER :: KPP_HCl_l = 0 
      INTEGER, PARAMETER :: KPP_HOCl_l = 0 
      INTEGER, PARAMETER :: KPP_Br_l = 0 
      INTEGER, PARAMETER :: KPP_Br2_l = 0 
      INTEGER, PARAMETER :: KPP_HBr_l = 0 
      INTEGER, PARAMETER :: KPP_HOBr_l = 0 
      INTEGER, PARAMETER :: KPP_BrCl_l = 0 
      INTEGER, PARAMETER :: KPP_I2_l = 0 
      INTEGER, PARAMETER :: KPP_IO_l = 0 
      INTEGER, PARAMETER :: KPP_HI_l = 0 
      INTEGER, PARAMETER :: KPP_HOI_l = 0 
      INTEGER, PARAMETER :: KPP_ICl_l = 0 
      INTEGER, PARAMETER :: KPP_IBr_l = 0 
      INTEGER, PARAMETER :: KPP_HIO3_l = 0 
      INTEGER, PARAMETER :: KPP_SO2_l = 0 
      INTEGER, PARAMETER :: KPP_H2SO4_l = 0 
      INTEGER, PARAMETER :: KPP_DMSO_l = 0 
      INTEGER, PARAMETER :: KPP_O2m_l = 0 
      INTEGER, PARAMETER :: KPP_OHm_l = 0 
      INTEGER, PARAMETER :: KPP_Hp_l = 0 
      INTEGER, PARAMETER :: KPP_NH4p_l = 0 
      INTEGER, PARAMETER :: KPP_NO2m_l = 0 
      INTEGER, PARAMETER :: KPP_NO3m_l = 0 
      INTEGER, PARAMETER :: KPP_NO4m_l = 0 
      INTEGER, PARAMETER :: KPP_CO3m_l = 0 
      INTEGER, PARAMETER :: KPP_HCOOm_l = 0 
      INTEGER, PARAMETER :: KPP_HCO3m_l = 0 
      INTEGER, PARAMETER :: KPP_CH3COOm_l = 0 
      INTEGER, PARAMETER :: KPP_Clm_l = 0 
      INTEGER, PARAMETER :: KPP_Cl2m_l = 0 
      INTEGER, PARAMETER :: KPP_ClOm_l = 0 
      INTEGER, PARAMETER :: KPP_ClOHm_l = 0 
      INTEGER, PARAMETER :: KPP_Brm_l = 0 
      INTEGER, PARAMETER :: KPP_Br2m_l = 0 
      INTEGER, PARAMETER :: KPP_BrOm_l = 0 
      INTEGER, PARAMETER :: KPP_BrOHm_l = 0 
      INTEGER, PARAMETER :: KPP_BrCl2m_l = 0 
      INTEGER, PARAMETER :: KPP_Br2Clm_l = 0 
      INTEGER, PARAMETER :: KPP_Im_l = 0 
      INTEGER, PARAMETER :: KPP_IO2m_l = 0 
      INTEGER, PARAMETER :: KPP_IO3m_l = 0 
      INTEGER, PARAMETER :: KPP_ICl2m_l = 0 
      INTEGER, PARAMETER :: KPP_IClBrm_l = 0 
      INTEGER, PARAMETER :: KPP_IBr2m_l = 0 
      INTEGER, PARAMETER :: KPP_SO3m_l = 0 
      INTEGER, PARAMETER :: KPP_SO3mm_l = 0 
      INTEGER, PARAMETER :: KPP_SO4m_l = 0 
      INTEGER, PARAMETER :: KPP_SO4mm_l = 0 
      INTEGER, PARAMETER :: KPP_SO5m_l = 0 
      INTEGER, PARAMETER :: KPP_HSO3m_l = 0 
      INTEGER, PARAMETER :: KPP_HSO4m_l = 0 
      INTEGER, PARAMETER :: KPP_HSO5m_l = 0 
      INTEGER, PARAMETER :: KPP_CH3SO3m_l = 0 
      INTEGER, PARAMETER :: KPP_CH2OHSO3m_l = 0 
      INTEGER, PARAMETER :: KPP_D1O_l = 0 
      INTEGER, PARAMETER :: KPP_D2O_l = 0 
      INTEGER, PARAMETER :: KPP_DAHp_l = 0 
      INTEGER, PARAMETER :: KPP_DA_l = 0 
      INTEGER, PARAMETER :: KPP_DAm_l = 0 
      INTEGER, PARAMETER :: KPP_DGtAi_l = 0 
      INTEGER, PARAMETER :: KPP_DGtAs_l = 0 
      INTEGER, PARAMETER :: KPP_PROD1_l = 0 
      INTEGER, PARAMETER :: KPP_PROD2_l = 0 
      INTEGER, PARAMETER :: KPP_Nap_l = 0 

! User defined variables                                           

      INTEGER :: ISNOTAUTONOM
      REAL(dp) :: STEPSTART

  ! from gas.eqn:
  REAL :: k_HO2_HO2, k_NO3_NO2, k_NO2_HO2, k_HNO3_OH, k_CH3OOH_OH, k_PA_NO2, &
          k_PAN_M, k_PrO2_HO2, k_PrO2_NO, k_PrO2_CH3O2, k_ClO_ClO, k_BrO_NO2, &
          k_I_NO2, k_DMS_OH
  REAL(dp) :: temp    ! temperature [K]
  REAL(dp) :: press   ! pressure [Pa]
  REAL(dp) :: cair    ! c(air) (wet) [mcl/cm^3]
  REAL(dp) :: &
    J_O2=0.,       J_O3P=0.,      J_O1D=0.,      J_H2O2=0.,     &
    J_NO2=0.,      J_NO2O=0.,     J_NOO2=0.,     J_N2O5=0.,     &
    J_HNO3=0.,     J_HNO4=0.,     J_PAN=0.,      J_HONO=0.,     &
    J_CH3OOH=0.,   J_COH2=0.,     J_CHOH=0.,     J_PAA=0.,      &
    J_CH3CHO=0.,   J_CH3COCH3=0., J_CH3COCHO=0., J_HOCl=0.,     &
    J_OClO=0.,     J_Cl2O2=0.,    J_ClNO3=0.,    J_ClNO2=0.,    &
    J_Cl2=0.,      J_BrO=0.,      J_HOBr=0.,     J_BrCl=0.,     &
    J_BrNO3=0.,    J_BrNO2=0.,    J_Br2=0.,      J_CCl4=0.,     &
    J_CH3Cl=0.,    J_CH3CCl3=0.,  J_CFCl3=0.,    J_CF2Cl2=0.,   &
    J_CH3Br=0.,    J_CF2ClBr=0.,  J_CF3Br=0.,    J_CH3I=0.,     &
    J_C3H7I=0.,    J_CH2ClI=0.,   J_CH2I2=0.,    J_IO=0.,       &
    J_HOI=0.,      J_I2=0.,       J_ICl=0.,      J_IBr=0.,      &
    J_INO2=0.,     J_INO3=0.,     J_SO2=0.,      J_SO3=0.,      &
    J_OCS=0.,      J_CS2=0.,      J_H2O=0.,      J_N2O=0.,      &
    J_NO=0.,       J_CO2=0.,      J_HCl=0.
  REAL(dp) :: &
    khet_N2O5_H2O  = 0., khet_HOCl_HCl  = 0., &
    khet_ClNO3_HCl = 0., khet_ClNO3_H2O = 0., &
    khet_N2O5_HCl  = 0., khet_ClNO3_HBr = 0., &
    khet_BrNO3_HCl = 0., khet_HOCl_HBr  = 0., &
    khet_HOBr_HCl  = 0., khet_HOBr_HBr  = 0., &
    khet_BrNO3_H2O = 0.
  ! mecca_mbl:
  INTEGER, PARAMETER :: AS =1
  INTEGER, PARAMETER :: CS =2       ! number of mode
  ! parameter for halogen chemistry
  INTEGER :: xaer(AS:CS)   ! aerosol in mode AS/CS exists yes(=1)/no(=0)
  INTEGER :: xnom7sulf = 1 ! Inverse of xm7sulf
  ! factor for unit conversion
  REAL(dp) :: cvfac(AS:CS)
  REAL(dp) :: lwc(AS:CS)        ! liquid water content of 3rd and 4th mode (M7)
  ! exchange coefficients
  REAL(dp) :: k_exf(AS:CS,NSPEC) = 0.
  REAL(dp) :: k_exb(AS:CS,NSPEC) = 0.
  REAL(dp) :: k_exf_N2O5(AS:CS)  = 0.
  REAL(dp) :: k_exf_ClNO3(AS:CS) = 0.
  REAL(dp) :: k_exf_BrNO3(AS:CS) = 0.
  ! Parameters included for acid-base equilibria calculation
  ! used to enable the double use of the aqueous.eqn for liquid 
  ! and aerosol phase.
  ! REAL(dp), PARAMETER :: &
  !             testfac_HNO3 = 1.,  testfac_HCOOH = 1. , testfac_SO2 =1.,  &
  !             testfac_HSO3m = 1., testfac_HSO4m = 1.,  testfac_NH3 = 1. , &
  !             testfac_H2O = 1.,   testfac_CO2 =1.
  REAL(dp), PARAMETER :: &
              testfac_HO2   = 1.e5_dp, testfac_HONO   = 1.e5_dp &
            , testfac_HNO3  = 1.e7_dp, testfac_HNO4   = 1.e5_dp &
            , testfac_HCOOH = 1.e5_dp, testfac_SO2    = 1.e9_dp &
            , testfac_HSO3m = 1.e9_dp, testfac_HSO4m  = 1.e7_dp &
            , testfac_NH3   = 1.e7_dp, testfac_H2O    = 1.e9_dp &
            , testfac_CO2   = 1.e5_dp, testfac_HCl    = 1.e2_dp &
            , testfac_Cl2m  = 1.e2_dp, testfac_HBr    = 1.e7_dp &
            , testfac_BrCl2 = 1.e5_dp, testfac_Br2Cl  = 1.e5_dp &
            , testfac_HOCl  = 1.e2_dp, testfac_Br2m   = 1.e2_dp &
            , testfac_HOBr  = 1.e2_dp, testfac_Br2Clm = 1.e5_dp &
            , testfac_ICl   = 1.e2_dp, testfac_IBr    = 1.e2_dp &
            , testfac_IClBr = 1.e2_dp, testfac_H2SO4  = 1.e7_dp

  ! from xmecca:
  LOGICAL, PARAMETER :: REQ_PSC     = .FALSE.
  LOGICAL, PARAMETER :: REQ_PHOTO   = .TRUE.
  LOGICAL, PARAMETER :: REQ_AEROSOL = .TRUE.

  ! from ros3.k:
  LOGICAL,  PARAMETER :: logsteps           = .FALSE.
  INTEGER,  PARAMETER :: nsubsteps          = 1
  REAL(dp), PARAMETER :: substep(nsubsteps) = (/ 0. /)

! End user defined variables                                       

END MODULE messy_mecca_kpp_g_mem

