! -*- f90 -*-
!*****************************************************************************
!                Time-stamp: <2004-11-17 20:48:54 sander>
!*****************************************************************************

! This dummy file produces ascii output. It can be used if no netcdf
! library is available.

MODULE mo_netcdf

  USE messy_main_constants_mem, ONLY: dp

  IMPLICIT NONE

  PRIVATE
  PUBLIC :: open_nc_file, write_nc_file, close_nc_file

CONTAINS

  !***************************************************************************

  FUNCTION find_next_free_unit() RESULT(unit)

    IMPLICIT NONE

    INTEGER :: unit
    LOGICAL :: found, opened
    INTEGER :: i
    
    found = .FALSE.
    DO i=100,200
      INQUIRE(unit=i,opened=opened)
      IF (.NOT.opened) THEN
        unit = i
        found = .TRUE.
        EXIT
      END IF
    END DO

  END FUNCTION find_next_free_unit

  !***************************************************************************

  SUBROUTINE open_nc_file (f90unit, filename, species, unit)

    IMPLICIT NONE

    CHARACTER(*), INTENT(IN) :: filename, species(:), unit(:)
    INTEGER, INTENT(OUT) :: f90unit

    INTEGER :: i

    f90unit = find_next_free_unit()

    OPEN(f90unit,file=filename//'.dat')

    DO i = 1, SIZE(species)
      WRITE (f90unit,'(I3,A,A20,2A)') &
        i, ') name = ', TRIM(species(i)), ', unit = ', TRIM(unit(i))
    END DO

  END SUBROUTINE open_nc_file

  !***************************************************************************

  SUBROUTINE write_nc_file (f90unit, time, x)

    IMPLICIT NONE

    INTEGER,  INTENT(IN) :: f90unit
    REAL(dp), INTENT(in) :: time
    REAL(dp), INTENT(in) :: x(:)

    INTEGER :: i

    ! write timestep
    WRITE (f90unit,*)
    WRITE (f90unit,*) 'time = ',time

    species_loop: DO i = 1, SIZE(x)
      WRITE (f90unit,'(I3,A,1PG17.8E3)') i, ') ', x(i)
    END DO species_loop

  END SUBROUTINE write_nc_file

  !***************************************************************************

  SUBROUTINE close_nc_file (f90unit)

    IMPLICIT NONE

    INTEGER, INTENT(IN) :: f90unit

    CLOSE (f90unit)

  END SUBROUTINE close_nc_file

  !***************************************************************************

END MODULE mo_netcdf

!*****************************************************************************
