! -- STEM INTEGRATION WITH RADAU5.F --
        PROGRAM STEM
        INCLUDE 'KPP_CRTFN.h'
! --- PARAMETERS FOR RADAU5 (FULL JACOBIAN)
        PARAMETER (ND=NVAR,LWORK=4*ND*ND+8*ND+20,LIWORK=3*ND+20)
        PARAMETER (LRCONT=4*ND+4)
        COMMON /CONT/ICONT(4),RCONT(LRCONT)
! --- PARAMETERS FOR SDIRK4 (FULL JACOBIAN)
!        PARAMETER (ND=NVAR,LWORK=2*ND*ND+12*ND+7,LIWORK=2*ND+7)
!        PARAMETER (LRCONT=5*ND+2)
!        COMMON /CONT/ICONT(4),RCONT(LRCONT)
! --- DECLARATIONS
        DIMENSION V(ND),WORK(LWORK),IWORK(LIWORK)
        KPP_REAL RPAR(1)
        INTEGER IPAR(1)
        COMMON/STAT/NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
        EXTERNAL FUN,JAC,SOLOUT
! --- DIMENSION OF THE SYSTEM
        N=NVAR
        write(6,*) 'RADAU5. Rtol=, DT='
        read(5,*) rtols,dt 
! --- COMPUTE THE JACOBIAN ANALYTICALLY (1) OR BY FINITE DIFF (0)
        IJAC=1
! --- JACOBIAN IS A FULL MATRIX
        MLJAC=N
! --- DIFFERENTIAL EQUATION IS IN EXPLICIT FORM
        IMAS=0
! --- OUTPUT ROUTINE IS USED DURING INTEGRATION
        IOUT=0
! --- REQUIRED TOLERANCE
!        RTOL=1.0D-4
        do i=1,n
          ATOL(i)=1.0D0*RTOLS
          RTOL(i)=rtols
        end do  
        ITOL=1
! ==== initial values ====
! ==== initial values ====
      CFACTOR = 8.12E+16
      CM = 1./CFACTOR
      TEMP = 241.42
      CALL INITVAL()
      DO i=1,NVAR
         V(i) = Var(i)
      END DO   
! --- ENDPOINT OF INTEGRATION
       NDAYS = 1
       TSTART = 12.D0*3600.D0
       TEND = TSTART + 24.D0*3600.D0*NDAYS
!--- INITIAL STEP SIZE
        H=0.1 
! --- SET DEFAULT VALUES 
        DO 10 I=1,20
        IWORK(I)=0
  10    WORK(I)=0.D0

! --- OUTPUT FILE ----
      OPEN(UNIT=10,FILE='Radau.m')
!      write(10,*) '% RADAU, ATOL = ',ATOL,'  RTOL = ',rtol
      write(10,*) 'r=['

       TIME=TSTART
! --- PRINT  INITIAL CONDITIONS
        write(6,95) 0.,Var(I_O)*CM
        write(10,99) 0., &
           Var(I_O)/CFACTOR, Var(I_O1D)/CFACTOR, &
           Var(I_O3)/CFACTOR, Var(I_NO)/CFACTOR, &
           Var(I_NO2)/CFACTOR, Var(I_NO3)/CFACTOR, &
           Var(I_N2O5)/CFACTOR, Var(I_HNO3)/CFACTOR, &
           Var(I_HNO4)/CFACTOR, Fix(I_H2O)/CFACTOR, & 
           Var(I_H)/CFACTOR, Var(I_OH)/CFACTOR, &
           Var(I_HO2)/CFACTOR, Var(I_H2O2)/CFACTOR, & 
           Fix(I_H2)/CFACTOR, Fix(I_CH4)/CFACTOR, &
           Var(I_CH3)/CFACTOR, Var(I_CH3O)/CFACTOR, & 
           Var(I_CH3O2)/CFACTOR, Var(I_CH3OOH)/CFACTOR, &
           Var(I_HCO)/CFACTOR, Var(I_CH2O)/CFACTOR,  &
           Fix(I_CO)/CFACTOR, Var(I_Cl)/CFACTOR, &
           Var(I_Cl2)/CFACTOR, Var(I_ClO)/CFACTOR, & 
           Var(I_ClOO)/CFACTOR, Var(I_OClO)/CFACTOR, &
           Var(I_Cl2O2)/CFACTOR, Var(I_HCl)/CFACTOR, & 
           Var(I_HOCl)/CFACTOR, Var(I_ClONO2)/CFACTOR, &
           Var(I_Br)/CFACTOR, Var(I_BrCl)/CFACTOR,  &
           Var(I_BrO)/CFACTOR, Var(I_HBr)/CFACTOR, &
           Var(I_HOBr)/CFACTOR, Var(I_BrONO2)/CFACTOR

        DO WHILE (TIME.LE.TEND)

! --- CALL OF THE SUBROUTINE RADAU5 (OR SDIRK4)
        CALL RADAU5(N,FUN,TIME,VAR,TIME+DT,H, &
!        CALL SDIRK4(N,FUN,TIME,VAR,TIME+DT,H,
                        RTOL,ATOL,ITOL, &
                        JAC,IJAC,MLJAC,MUJAC, &
                        FUN,IMAS,MLMAS,MUMAS, &
                        SOLOUT,IOUT, &
                        WORK,LWORK,IWORK,LIWORK,RPAR,IPAR,IDID) &
!                        WORK,LWORK,IWORK,LIWORK,LRCONT,IDID)

!       TIME=TIME+DT
! --- PRINT  SOLUTION
        if (time.le.tend) then
        write(10,99) (TIME-Tstart)/3600.D0, 
           Var(I_O)/CFACTOR, Var(I_O1D)/CFACTOR,  &
           Var(I_O3)/CFACTOR, Var(I_NO)/CFACTOR, &
           Var(I_NO2)/CFACTOR, Var(I_NO3)/CFACTOR, & 
           Var(I_N2O5)/CFACTOR, Var(I_HNO3)/CFACTOR, &
           Var(I_HNO4)/CFACTOR, Fix(I_H2O)/CFACTOR, & 
           Var(I_H)/CFACTOR, Var(I_OH)/CFACTOR, &
           Var(I_HO2)/CFACTOR, Var(I_H2O2)/CFACTOR,  &
           Fix(I_H2)/CFACTOR, Fix(I_CH4)/CFACTOR, &
           Var(I_CH3)/CFACTOR, Var(I_CH3O)/CFACTOR, & 
           Var(I_CH3O2)/CFACTOR, Var(I_CH3OOH)/CFACTOR, &
           Var(I_HCO)/CFACTOR, Var(I_CH2O)/CFACTOR,  &
           Fix(I_CO)/CFACTOR, Var(I_Cl)/CFACTOR, &
           Var(I_Cl2)/CFACTOR, Var(I_ClO)/CFACTOR, & 
           Var(I_ClOO)/CFACTOR, Var(I_OClO)/CFACTOR, &
           Var(I_Cl2O2)/CFACTOR, Var(I_HCl)/CFACTOR,  &
           Var(I_HOCl)/CFACTOR, Var(I_ClONO2)/CFACTOR, &
           Var(I_Br)/CFACTOR, Var(I_BrCl)/CFACTOR,  &
           Var(I_BrO)/CFACTOR, Var(I_HBr)/CFACTOR, &
           Var(I_HOBr)/CFACTOR, Var(I_BrONO2)/CFACTOR 


        end if
        percent=100.D0*(time-tstart)/(tend-tstart)
        write(6,95) percent,Var(I_O)*CM
 95     format(F7.2,' % DONE. O = ',E12.5)       
 99     FORMAT(100(1X,E24.16))
         END DO
        write(10,*) '];'



! --- PRINT STATISTICS
        WRITE (6,91) NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
 91     FORMAT(' fcn=',I5,' jac=',I4,' step=',I4, &
              ' accpt=',I4,' rejct=',I3,' dec=',I4, &
              ' sol=',I5)
        STOP
        END
!
!
