! -- STEM INTEGRATION WITH VODE.F --
        PROGRAM STEM
	INCLUDE 'KPP_CRTFN.h'
! --- PARAMETERS (FULL JACOBIAN)
        PARAMETER (ND=34,LRW=6*ND*ND+9*ND+25,LIW=ND+35)
        PARAMETER (LRCONT=4*ND+4+10)
        COMMON /CONT/ICONT(4),RCONT(LRCONT)
! --- DECLARATIONS
        DIMENSION V(ND),RWORK(LRW),IWORK(LIW),ATOL(ND)
        COMMON/STAT/NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
        EXTERNAL FUN,FUN2,JAC,JAC2

        write(6,*) 'VODE. rtol=, dt, direct='
        read(5,*) rtol, dt, idir
        
        MF = 22
        
! --- DIMENSION OF THE SYSTEM
        N=NVAR
! ==== initial values ====
      CFACTOR = 8.12E+16
      CM = 1./CFACTOR
      CALL INITVAL()
      DO i=1,NVAR
         V(i) = Var(i)
      END DO   


! --- ENDPOINT OF INTEGRATION
       NDAYS = 1
       TSTART = 12.D0*3600.D0
       TEND = TSTART + 24.D0*3600.D0*NDAYS
! --- REQUIRED TOLERANCE, scalar ATOL (itol = 2), vector ATOL (itol = 2)
!        RTOL=1.0D-3
        do i=1,nd
          ATOL(i)=1E-18
        end do  
        ITOL=2
! ---- NORMAL COMPUTATION ---
        itask=1
        istate=1
        iopt=0

! --- OUTPUT FILE ----
      OPEN(UNIT=10,FILE='Vode.m')
!      write(10,*) '% VODE, ATOL = ',ATOL,'  RTOL = ',rtol
      write(10,*) 'v=['
      OPEN(UNIT=20,FILE='Vodereport.m')

       TIME=TSTART
! --- PRINT  INITIAL CONDITIONS
        write(10,99) 0., & 
           Var(I_O)/CFACTOR, Var(I_O1D)/CFACTOR, & 
           Var(I_O3)/CFACTOR, Var(I_NO)/CFACTOR, &
           Var(I_NO2)/CFACTOR, Var(I_NO3)/CFACTOR, & 
           Var(I_N2O5)/CFACTOR, Var(I_HNO3)/CFACTOR, &
           Var(I_HNO4)/CFACTOR, Fix(I_H2O)/CFACTOR, & 
           Var(I_H)/CFACTOR, Var(I_OH)/CFACTOR, &
           Var(I_HO2)/CFACTOR, Var(I_H2O2)/CFACTOR, & 
           Fix(I_H2)/CFACTOR, Fix(I_CH4)/CFACTOR, &
           Var(I_CH3)/CFACTOR, Var(I_CH3O)/CFACTOR, & 
           Var(I_CH3O2)/CFACTOR, Var(I_CH3OOH)/CFACTOR, &
           Var(I_HCO)/CFACTOR, Var(I_CH2O)/CFACTOR,  &
           Fix(I_CO)/CFACTOR, Var(I_Cl)/CFACTOR, &
           Var(I_Cl2)/CFACTOR, Var(I_ClO)/CFACTOR, & 
           Var(I_ClOO)/CFACTOR, Var(I_OClO)/CFACTOR, &
           Var(I_Cl2O2)/CFACTOR, Var(I_HCl)/CFACTOR,  &
           Var(I_HOCl)/CFACTOR, Var(I_ClONO2)/CFACTOR, &
           Var(I_Br)/CFACTOR, Var(I_BrCl)/CFACTOR,  &
           Var(I_BrO)/CFACTOR, Var(I_HBr)/CFACTOR, &
           Var(I_HOBr)/CFACTOR, Var(I_BrONO2)/CFACTOR
!        DT=900.D0

        DO WHILE (TIME.LE.TEND)

! --- CALL OF THE SUBROUTINE VODE
       
       if (idir.eq.0) istate=1
       
       CALL dvode (FUN, N, V, TIME, TIME+DT, itol, rtol, atol,
     1             itask, istate, iopt, RWORK, lrw, 
     2             IWORK, liw, JAC, mf,rpar,ipar)

       IF (ISTATE.LT.0) THEN
          WRITE(6,*) 'VODE WARNING:: ISTATE = ',ISTATE
       END IF   
! --- PRINT  SOLUTION
       if (time.le.tend) then
        write(10,99) (TIME-Tstart)/3600.D0, &  
           Var(I_O)/CFACTOR, Var(I_O1D)/CFACTOR, & 
           Var(I_O3)/CFACTOR, Var(I_NO)/CFACTOR, &
           Var(I_NO2)/CFACTOR, Var(I_NO3)/CFACTOR, & 
           Var(I_N2O5)/CFACTOR, Var(I_HNO3)/CFACTOR, &
           Var(I_HNO4)/CFACTOR, Fix(I_H2O)/CFACTOR, & 
           Var(I_H)/CFACTOR, Var(I_OH)/CFACTOR, &
           Var(I_HO2)/CFACTOR, Var(I_H2O2)/CFACTOR, & 
           Fix(I_H2)/CFACTOR, Fix(I_CH4)/CFACTOR, &
           Var(I_CH3)/CFACTOR, Var(I_CH3O)/CFACTOR,  &
           Var(I_CH3O2)/CFACTOR, Var(I_CH3OOH)/CFACTOR, &
           Var(I_HCO)/CFACTOR, Var(I_CH2O)/CFACTOR, & 
           Fix(I_CO)/CFACTOR, Var(I_Cl)/CFACTOR, &
           Var(I_Cl2)/CFACTOR, Var(I_ClO)/CFACTOR,  &
           Var(I_ClOO)/CFACTOR, Var(I_OClO)/CFACTOR, &
           Var(I_Cl2O2)/CFACTOR, Var(I_HCl)/CFACTOR,  &
           Var(I_HOCl)/CFACTOR, Var(I_ClONO2)/CFACTOR, &
           Var(I_Br)/CFACTOR, Var(I_BrCl)/CFACTOR,  &
           Var(I_BrO)/CFACTOR, Var(I_HBr)/CFACTOR, &
           Var(I_HOBr)/CFACTOR, Var(I_BrONO2)/CFACTOR


        write(20,101) (TIME-tstart)/3600.D0,RWORK(11), &
              IWORK(14),V(3)*CM
        percent=100.D0*(time-tstart)/(tend-tstart)
!        write(6,95) percent,V(8)*CM
        end if
 95     format(F7.2,' % DONE, O3=',F10.4)       
 99     FORMAT(10(1X,E24.16))
 101    format(E24.16,E24.16,1X,I4,1X,E24.16)
         END DO
 
        write(10,*) '];'
! --- PRINT STATISTICS
        WRITE (6,90) real(IWORK(21))/IWORK(11)*100., &
                    real(IWORK(22))/IWORK(11)*100.
 90     FORMAT(F9.3,' % conv, ',F9.3,'% err failures')
        CLOSE(10)
        STOP
        END
!
!

        SUBROUTINE FUN2 (N, T, V, FCT, rpar, ipar)
	INCLUDE 'KPP_CRTFN.h'
        DIMENSION V(NVAR), FCT(NVAR), rpar(*)
        integer IPAR(*)
        TOLD = TIME
        TIME = T
        CALL UPDATE_SUN()
        CALL UPDATE_RCONST()
        TIME = TOLD
        CALL F_VAR(V, Rad, FCT) 
        END SUBROUTINE FUN2

        SUBROUTINE JAC2 (N, T, V, ML, MU, JV, NROWPD, RPAR, IPAR)
	INCLUDE 'KPP_CRTFN.h'
        KPP_REAL V(NVAR), JV(NVAR,NVAR), rpar(*)
        integer ipar(*)
        TOLD = TIME
        TIME = T
        CALL UPDATE_SUN()
        CALL UPDATE_RCONST()
        TIME = TOLD
        DO i=1,NVAR
           DO j=1,NVAR
              JV(i,j) = 0.
           END DO
        END DO      
        CALL JACVAR(V, Rad, JV) 
        END SUBROUTINE JAC2
        
