C **************************************************************** 
C                                                                  
C MAIN - Main program - driver routine                             
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

C -- INTEGRATION WITH ATMSDIRK.F --
        PROGRAM STEM
      INCLUDE 'KPP_CRTFN.h'
C --- PARAMETERS FOR SDIRK4 (FULL JACOBIAN)
        PARAMETER (ND=NVAR,LWORK=2*ND*ND+12*ND+7,LIWORK=2*ND+7)
        PARAMETER (LRCONT=5*ND+2)
        COMMON /CONT/ICONT(4),RCONT(LRCONT)
C --- DECLARATIONS
        DIMENSION V(ND),WORK(LWORK),IWORK(LIWORK)
C        DIMENSION ATOL(NVAR), RTOL(NVAR)
        COMMON/STAT/NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
        EXTERNAL FUN,JAC


C --- DIMENSION OF THE SYSTEM
        N=NVAR
        write(6,*) 'SDIRK4. Rtol='
        read(5,*) rtols
        DT = 3600. 
        IJAC=1
        MLJAC=N     
        IMAS=0     
        IOUT=0     

        atols = MIN(1.D-5, 0.01*rtols)
        do i=1,n
          ATOL(i)= DMAX1(1.D-1, atols*Var(i)) 
          RTOL(i)=rtols
        end do  
        ITOL=1
        
C ==== initial values ====
      CFACTOR = 1.09E+10
      CM = 1./CFACTOR
      TEMP = 236.21
      CALL INITVAL()
      DO i=1,NVAR
         V(i) = Var(i)
      END DO   
C --- ENDPOINT OF INTEGRATION
       NDAYS = 5
       TSTART = 12.D0*3600.D0
       TEND = TSTART + 24.D0*3600.D0*NDAYS
C --- INITIAL STEP SIZE
        H=0.1 
C --- SET DEFAULT VALUES 
        DO 10 I=1,20
        IWORK(I)=0
  10    WORK(I)=0.D0
  
      IWORK(3) = 8

C --- OUTPUT FILE ----
      OPEN(UNIT=10,FILE='Sdirk.m')

       TIME=TSTART
C --- PRINT  INITIAL CONDITIONS
        write(6,95) 0.,V(I_O3)*CM

C        write(10,99) 0., (VAR(i), i=1,nvar)

        DO WHILE (TIME.LT.TEND)

        CALL ATMSDIRK(N,FUN,TIME,VAR,TIME+DT,H,
     &                  RTOL,ATOL,ITOL,
     &                  JAC,IJAC, FUN,IMAS,
     &                  WORK,LWORK,IWORK,LIWORK,LRCONT,IDID)

C --- PRINT  SOLUTION
        if (time.le.tend) then
C        write(10,99) (TIME-Tstart)/3600.D0,  (VAR(i), i=1,nvar)


        end if
c        percent=100.D0*(time-tstart)/(tend-tstart)
c        write(6,95) percent,Var(I_O3)*CM
 95     format(F7.2,' % DONE. O3 = ',E16.8)       
 99     FORMAT(100(1X,E24.16))
         END DO
C        write(10,*) '];'
        percent=100.D0*(time-tstart)/(tend-tstart)
        write(6,95) percent,Var(I_O3)*CM



C --- PRINT STATISTICS
        WRITE (6,91) NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
 91     FORMAT(' fcn=',I5,' jac=',I4,' step=',I4,
     &        ' accpt=',I4,' rejct=',I3,' dec=',I4,
     &        ' sol=',I5)
        STOP
        END
C
        
C End of MAIN function                                             
C **************************************************************** 

