! **************************************************************** 
!                                                                  
! MAIN - Main program - driver routine                             
!   Parameters :                                                   
!                                                                  
! **************************************************************** 

! -- STEM INTEGRATION WITH ATMSDIRK.F --
        PROGRAM STEM
      INCLUDE 'KPP_CRTFN.h'
! --- PARAMETERS FOR SDIRK4 (FULL JACOBIAN)
        PARAMETER (ND=NVAR,LWORK=2*ND*ND+12*ND+7,LIWORK=2*ND+7)
        PARAMETER (LRCONT=5*ND+2)
        COMMON /CONT/ICONT(4),RCONT(LRCONT)
! --- DECLARATIONS
        DIMENSION V(ND),WORK(LWORK),IWORK(LIWORK)
!        DIMENSION ATOL(NVAR), RTOL(NVAR)
        COMMON/STAT/NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
        EXTERNAL FUN,JAC
        DIMENSION VMIN(ND)
	DIMENSION DMIN1(ND,ND)
      data VMIN/
     *1.09e+10, 109.289, 112.658, 111.311, 153.409,
     *119.725, 160.15, 109.553, 109.003, 119.97,
     *9.19146e-10, 9.86303e-06, 0.00345618, 3.78711e-99, 1.16672e-42,
     *1.4994e-31, 105.142, 0.19963, 101.62, 65.734,
     *163.347, 167.496, 1.18219e+10, 0.00105858, 203.947,
     *0.480246, 558932, 39.1743, 1.85098e+13, 17.505,
     *5.44834e+08, 580.626, 1.5868e+06, 8.60999e-05, 0.000168658,
     *0.00411799, 118240, 0.271216, 1.06036e-05, 0.00851112,
     *9.68917e+11, 0.171067, 1.71123e-19, 2.84471e-05, 0.00276744,
     *0.0823171, 0.000248949, 5.62985e-15, 3.50803e-13, 5.15201e-13,
     *0.0497651, 2.98567e-20, 8.11453e-34, 0.000570524, 6.36574e-39,
     *0.00067, 2.56481e+08, 2.97396e-05, 9.16592e-08, 5.53284e-14,
     *0.0870709, 120.951, 0.0512459, 2.01264e-33, 2.85183e+06,
     *0.000324338, 1.9635e-16, 3.0129e-10, 8.5977e-37, 1.28966e-36,
     *3.38201e+07, 0.0153051, 4.29254e-12, 1.06483e+12, 1.50614e-06,
     *6.98185e+07, 4.74384e+08, 5.45e+10, 7.15763, 8.5378e-07,
     *5.27401, 9.6356e+06, 6593.71, 52448.8/


! --- DIMENSION OF THE SYSTEM
        N=NVAR
        write(6,*) 'SDIRK4. Rtol='
        read(5,*) rtols
        DT = 3600. 
        IJAC=1
        MLJAC=N     
        IMAS=0     
        IOUT=0     

        atols = DMIN1(1.D-5, 0.01*rtols)
        do i=1,n
          ATOL(i)= DMAX1(1.D-1, atols*VMIN(i)) 
          RTOL(i)=rtols
        end do  
        ITOL=1
        
! ==== initial values ====
      CFACTOR = 1.09E+10
      CM = 1./CFACTOR
      TEMP = 236.21
      CALL INITVAL()
      DO i=1,NVAR
         V(i) = Var(i)
      END DO   
! --- ENDPOINT OF INTEGRATION
       NDAYS = 5
       TSTART = 12.D0*3600.D0
       TEND = TSTART + 24.D0*3600.D0*NDAYS
! --- INITIAL STEP SIZE
        H=0.1 
! --- SET DEFAULT VALUES 
        DO 10 I=1,20
        IWORK(I)=0
  10    WORK(I)=0.D0
  
      IWORK(3) = 8

! --- OUTPUT FILE ----
      OPEN(UNIT=10,FILE='Sdirk.m')

       TIME=TSTART
! --- PRINT  INITIAL CONDITIONS
        write(6,95) 0.,V(I_O3)*CM

!        write(10,99) 0., (VAR(i), i=1,nvar)

        DO WHILE (TIME.LT.TEND)

        CALL ATMSDIRK(N,FUN,TIME,VAR,TIME+DT,H,
     &                  RTOL,ATOL,ITOL,
     &                  JAC,IJAC, FUN,IMAS,
     &                  WORK,LWORK,IWORK,LIWORK,LRCONT,IDID)

! --- PRINT  SOLUTION
        if (time.le.tend) then
!        write(10,99) (TIME-Tstart)/3600.D0,  (VAR(i), i=1,nvar)


        end if
!        percent=100.D0*(time-tstart)/(tend-tstart)
!        write(6,95) percent,Var(I_O3)*CM
 95     format(F7.2,' % DONE. O3 = ',E16.8)       
 99     FORMAT(100(1X,E24.16))
         END DO
!        write(10,*) '];'
        percent=100.D0*(time-tstart)/(tend-tstart)
        write(6,95) percent,Var(I_O3)*CM



! --- PRINT STATISTICS
        WRITE (6,91) NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
 91     FORMAT(' fcn=',I5,' jac=',I4,' step=',I4,
     &        ' accpt=',I4,' rejct=',I3,' dec=',I4,
     &        ' sol=',I5)
        STOP
        END
!
!

        SUBROUTINE FUN (N, T, V, FCT)
      INCLUDE 'KPP_CRTFN.h'
        DIMENSION V(NVAR), FCT(NVAR)
        TOLD = TIME
        TIME = T
        CALL update_sun()
        CALL update_rconst()
        TIME = TOLD
        CALL F_VAR(V, Rad, FCT) 
        END SUBROUTINE

        SUBROUTINE JAC (N, T, V, J)
        INCLUDE 'KPP_CRTFN.h'
        KPP_REAL Told, T
        KPP_REAL V(NVAR), J(LU_NONZERO_V)  

        Told = TIME
        TIME = T
        CALL UPDATE_SUN()
        CALL UPDATE_RCONST()
        CALL JACVAR_SP( V, RAD, J )
        TIME = Told
        END SUBROUTINE
        
! End of MAIN function                                             
! **************************************************************** 

