#include "ncar.h"

float val[NSPEC];

void main()
{
KPP_REAL dval[NSPEC];
FILE * fp;
int i;
int n;
 
/* ---- TIME VARIABLES ------------------ */

  RTOLS = 1e-3;
  TSTART = 3600*12;
  TEND = TSTART + 3600*24*5;
  DT = 3600.;
  TEMP = 236.21;

  INITVAL();
      
  for( i = 0; i < NVAR; i++ ) {
    RTOL[i] = RTOLS;
    ATOL[i] = 1E-18;
  }
  STEPMIN = 0.01;
  STEPMAX = 900;
      
/* ********** TIME LOOP **************************** */

  InitSaveData();
  OpenWin();

  for( i = 0; i < NMONITOR; i++ )  
    DefineGraph( SMONITOR[i], 1.0, 1.0 );

  for( i = 0; i < NMASS; i++ )  
    DefineGraph( SMASS[i], 20*RTOLS, 20*RTOLS );
  
  n = (TEND-TSTART)/DT;

  InitGraph( n, TSTART/3600.0, TEND/3600.0, "KPP monitor" );

  TIME = TSTART;
  while (TIME <= TEND) {
    GETMASS( dval );
    for( i = 0; i < NMONITOR; i++ ) 
      val[i] = C[ MONITOR[i] ]/CFACTOR;
    for( i = 0; i < NMASS; i++ ) 
      val[NMONITOR + i] = dval[i]/CFACTOR;
    
    UpdateGraph( val );

    SaveData();

    UPDATE_SUN(); 
    UPDATE_RCONST();

    INTEGRATE( DT );
  }

/* *********** END TIME LOOP *********************** */

  CloseSaveData();
  GenerateMatlab("");
  
  CloseWin();
}
