      HP9000_800 INTRINSICS

      PROGRAM driver

      INCLUDE 'KPP_CRTFN.h'

      KPP_REAL DVAL(NSPEC)
      INTEGER i
      INTEGER NMONITOR_DUMMY, NMASS_DUMMY
      CHARACTER*30 SRTOL
 
      NMONITOR_DUMMY = NMONITOR
      NMASS_DUMMY = NMASS

      TSTART = 0
      TEND = TSTART + 600
      DT = 60.
      TEMP = 298

      STEPMIN = 0.01
      STEPMAX = 900

      RTOLS = 1e-2
      do i=1,NVAR
        RTOL(i) = RTOLS
        ATOL(i) = 1
      end do
     
      CALL INITVAL()

      i = igetarg(1,SRTOL,30)
      if( i.ge.0 ) then
        RTOLS = DNUM(SRTOL)
        do i=1,NVAR
          RTOL(i) = RTOLS
          ATOL(i) = 1E-8
        end do
      endif

! ********** TIME LOOP *************************

      CALL InitSaveData()

      write(6,990) (SMONITOR(i), i=1,NMONITOR_DUMMY),  &
                   (SMASS(i), i=1,NMASS_DUMMY )
990   FORMAT('done[%] Time[h] ',20(4X,A6))

      TIME = TSTART
      do while (TIME .lt. TEND)

        CALL GETMASS( DVAL )
        write(6,991) (TIME-TSTART)/(TEND-TSTART)*100, TIME/3600., &
                     (C(MONITOR(i))/CFACTOR, i=1,NMONITOR_DUMMY), &
                     (DVAL(i)/CFACTOR, i=1,NMASS_DUMMY)
991   FORMAT(F6.1,'% ',F7.2,3X,20(E10.4,2X))

        CALL SaveData()

        CALL UPDATE_SUN() 
        CALL UPDATE_RCONST()

        CALL INTEGRATE( TIME, TIME+DT )

      end do

      CALL GETMASS( DVAL )
      write(6,991) (TIME-TSTART)/(TEND-TSTART)*100, TIME/3600., &
                     (C(MONITOR(i))/CFACTOR, i=1,NMONITOR_DUMMY), &
                     (DVAL(i)/CFACTOR, i=1,NMASS_DUMMY) 

      CALL SaveData()

! *********** END TIME LOOP ********

      CALL CloseSaveData()
      CALL GenerateMatlab(' ')

      STOP
      END

