      PROGRAM driver

      INCLUDE 'KPP_CRTFN.h'

      KPP_REAL DVAL(NSPEC)
      INTEGER i
      INTEGER NMONITOR_DUMMY, NMASS_DUMMY
      KPP_REAL exact(NSPEC)
      KPP_REAL sumerr(NSPEC)
      KPP_REAL max_error, med_error
      KPP_REAL e
      INTEGER nl(NSPEC)

      NMONITOR_DUMMY = NMONITOR
      NMASS_DUMMY = NMASS
  
! ---- TIME VARIABLES ------------------      

      TSTART = 0
      TEND = TSTART + 600
      DT = 60.
      TEMP = 298

      STEPMIN = 0.01
      STEPMAX = 900

      RTOLS = 1e-2
      do i=1,NVAR
        RTOL(i) = RTOLS
        ATOL(i) = 1
      end do
     
      CALL INITVAL()

      open(20, file='exact.dat')

      do i=1,NLOOKAT
        sumerr(i) = 0.0D0
        nl(i) = 0
      end do

! ********** TIME LOOP *************************

      write(6,990) (SMONITOR(i), i=1,NMONITOR_DUMMY),  &
                   (SMASS(i), i=1,NMASS_DUMMY )
990   FORMAT('done[%] Time[h] ',20(4X,A6))

      TIME = TSTART
      do while (TIME .lt. TEND)

        CALL GETMASS( DVAL )
        write(6,991) (TIME-TSTART)/(TEND-TSTART)*100, TIME/3600., &
                     (C(MONITOR(i))/CFACTOR, i=1,NMONITOR_DUMMY), &
                     (DVAL(i)/CFACTOR, i=1,NMASS_DUMMY)
991     FORMAT(F6.1,'% ',F7.2,3X,20(E10.4,2X))

        read(20,999) e, (exact(i), i=1,NLOOKAT) 
999     FORMAT(E24.16,100(1X,E24.16))

        do i=1,NLOOKAT
          if (exact(i).GT.1e-18) then
            nl(i) = nl(i)+1
            e = abs((exact(i) - C(LOOKAT(i))/CFACTOR)/exact(i))
            sumerr(i) = sumerr(i) + e*e
          end if
        end do

        CALL UPDATE_SUN() 
        CALL UPDATE_RCONST()

        CALL INTEGRATE( TIME, TIME+DT )

      end do

      CALL GETMASS( DVAL )
      write(6,991) (TIME-TSTART)/(TEND-TSTART)*100, TIME/3600., &
                     (C(MONITOR(i))/CFACTOR, i=1,NMONITOR_DUMMY), &
                     (DVAL(i)/CFACTOR, i=1,NMASS_DUMMY)

! *********** END TIME LOOP ********

      close(20)      

      max_error = 0
      med_error = 0

      do i=1,NLOOKAT
        sumerr(i) = sqrt(sumerr(i)/nl(i))
        med_error = med_error + sumerr(i)
        if (sumerr(i).GT.max_error) then
          max_error = sumerr(i) 
        end if
      end do
   
      med_error = med_error/NLOOKAT

      write(6,992) RTOLS, med_error, max_error 
992   FORMAT('Tolerance / Mean Err / Max Err :: ', &
              E12.4,2(1X,E12.4))      

      STOP
      END

