! ****************************************************************
!                            
! InitSaveData - Opens the data file for writing
!   Parameters :                                                  
!
! ****************************************************************

      SUBROUTINE InitSaveData ()

!      INCLUDE 'KPP_CRTFN.h'
      USE GDATA

      open(10, file='KPP_CRTFN.dat')

      END SUBROUTINE InitSaveData

! End of InitSaveData function
! ****************************************************************

! ****************************************************************
!                            
! SaveData - Write LOOKAT species in the data file 
!   Parameters :                                                  
!
! ****************************************************************

      SUBROUTINE SaveData ()

!      INCLUDE 'KPP_CRTFN.h'
      USE GDATA

      INTEGER i

      WRITE(10,999) (TIME-TSTART)/3600., &
                    (C(LOOKAT(i))/CFACTOR, i=1,NLOOKAT)
999   FORMAT(E24.16,100(1X,E24.16))

      END SUBROUTINE SaveData

! End of SaveData function
! ****************************************************************

! ****************************************************************
!                            
! CloseSaveData - Close the data file 
!   Parameters :                                                  
!
! ****************************************************************

      SUBROUTINE CloseSaveData ()

!      INCLUDE 'KPP_CRTFN.h'
      USE GDATA

      CLOSE(10)

      END SUBROUTINE CloseSaveData

! End of CloseSaveData function
! ****************************************************************

! ****************************************************************
!                            
! GenerateMatlab - Generates MATLAB file to load the data file 
!   Parameters : 
!                It will have a character string to prefix each 
!                species name with.                                                 
!
! ****************************************************************

      SUBROUTINE GenerateMatlab ( PREFIX )

!      INCLUDE 'KPP_CRTFN.h'
      USE GDATA 
      CHARACTER*8 PREFIX 
      INTEGER i

      open(20, file='KPP_CRTFN.m')
      write(20,*) 'load KPP_CRTFN.dat;'
      write(20,990) PREFIX
990   FORMAT(A1,'c = KPP_CRTFN;')
      write(20,*) 'clear KPP_CRTFN;'
      write(20,991) PREFIX, PREFIX
991   FORMAT(A1,'t=',A1,'c(::,1);')
      write(20,992) PREFIX
992   FORMAT(A1,'c(::,1)=[];')

      do i=1,NLOOKAT
        write(20,993) PREFIX, SLOOKAT(i), PREFIX, i
993     FORMAT(A1,A6,' = ',A1,'c(::,',I2,');')
      end do
      
      CLOSE(20)

      END SUBROUTINE GenerateMatlab

! End of GenerateMatlab function
! ****************************************************************

